/********************************* to column 80******************************
 Main Class:       CD Class
 Author:           Yannis Lau <yylau2@students.wisc.edu>
 Completion Date:  12-16-99
 Course:           CS 302, Fall '99, Section 311
 TA:               Daniel Tomko
 Assignment:       Project 2

 Compiler:         CodeWarrior (JDK 1.2)
 Platform:         Windows NT 4.0
 ****************************************************************************/
import java.io.*;
import java.util.*;
 /**
  * Represent a CD object and for other classes using the CD
  * and collect all Song objects
  *
  * Bugs: none known
  **/

 class CD
 {
/**
 * DATA MEMBERS
 **/

 	private String artist;        // Artist of the CD
 	private String title;         // Title name of the CD
 	private int year;             // Year of release of the CD
 	private int numOfSong;        // number of songs in the CD
 	private Song[] songs;         // Declare songs array
 	private int songsIndexLast;	  // last used element of song array
 	private BufferedReader stdin; // use to read input from console
 	private int totalMin;         // total time (minutes) of the CD
 	private int totalSec;         // total time (seconds) of the CD
 	private int matchSongIndex;   // song index of matched song name
 	private int searchSongFound;  // count the result of matched
 								  // song name found

/**
 * CONSTRUCTOR
 * Construct:
 *   -year of release not smaller than 1900
 *    and not larger than 1999
 *   -a songs array for storing all songs in the CD
 *   -total minutes is 0
 *   -total seconds is 0
 *   -index of song of the matched song name in the CD
 * @param: number of songs in the CD
 **/

 	public CD(int numOfSong)
 	{
 	// initialize number of songs
 	   this.numOfSong = numOfSong;

 	// initialize songs array size
 	   songs = new Song[numOfSong];

 	// initialize last used index element
 	   songsIndexLast = -1;

 	// initialize total time, min and sec be 0
 	   totalMin = 0;
 	   totalSec = 0;

    // initialize year of release
       this.year = year;

 	// assume result of the song name search is none
 	   matchSongIndex = -1;
 	}

 /**
  * Default Constructor
  **/
 	public CD()
 	{
 	// initialize number of songs
 	   this.numOfSong = numOfSong;

 	// initialize last used index element
 	   songsIndexLast = -1;

 	// initialize total time, min and sec be 0
 	   totalMin = 0;
 	   totalSec = 0;

    // initialize year of release
       this.year = year;

 	// assume result of the song name search is none
 	   matchSongIndex = -1;

 	}

/****************************************************************
		Accessors
 ****************************************************************/

/**
 * Set all CD's information at once
 * using private methods in the same class
 * purpose: shorten the length in the calling side
 **/
  	public void setCD(BufferedReader stdin, String artist,
  	                  String title, int year,
  	                  int numOfSong) throws IOException
  	{
  		setArtist(artist);
  		setTitle(title);
  		setYear(year);
  		setNumOfSong(numOfSong);
  		addSong(stdin, numOfSong);
  	}

/**
 * Set the CD information for loading file
 **/
 	public void updateCD(String artist, String title,
 	                     int year, int numOfSong)
 	{
 		setArtist(artist);
 		setTitle(title);
 		setYear(year);
 		setNumOfSong(numOfSong);
 	}

/**
 * Set Artist name
 * @param: (String) artist name of the CD
 *
 */
 	public void setArtist(String artist)
 	{
 		this.artist = artist;
 	}

/**
 * Set CD Title
 * @param: (String) title of the CD
 *
 */
 	public void setTitle(String title)
 	{
 		this.title = title;
 	}

/**
 * Set Year of Release
 * @param: (int) year of relesase of the CD
 *
 */
 	public void setYear(int year)

 	{
 		this.year = year;
	}

/**
 * Set Number of Song
 * @param: (int) number of songs in the CD
 *
 */
	public void setNumOfSong(int numOfSong)

	{
	   this.numOfSong = numOfSong;
	}

/**
 * Set total minute from the load file
 * @param: (int) total minute
 **/
 	public void setTotalMin(int minuteSum)
 	{
 		totalMin = minuteSum;
 	}

/**
 * Set total Second from the load file
 * @param: (int) total second
 **/
 	public void setTotalSec(int secondSum)
 	{
 		totalSec = secondSum;
 	}

/**
 * Set a Song from the load file
 **/
 	public void setSong(String songName, int minutes,
 						int seconds) throws IOException
 	{
	 // add all songs to the CD
	 // create a song object
	    Song song = new Song();

	 // increase songs index by one
	    songsIndexLast++;

 	 // set all song's information
	    song.setSongName(songName);
	    song.setSongMins(minutes);
	    song.setSongSecs(seconds);

	 // assign song object to the songs array
	    songs[songsIndexLast] = song;

	}

/***************************************************************
		Mutators
 ***************************************************************/

/**
 * Return CD Title
 * @return: (String) title fo the CD
 **/
  	public String getTitle()
  	{
  		return title;
  	}

/**
 * Return Year of Release
 * @return: (int) year of release of the CD
 **/
  	public int getYear()
  	{
  		return year;
  	}

/**
 * Return Number of Song
 * @return: (int) number of song in the CD
 **/
   	public int getNumOfSong()
   	{
   		return numOfSong;
   	}

/**
 * Get Total minutes of the CD
 * total minute is set in the addSong method
 * @return: (int) total minutes
 *
 **/
 	public int getTotalMin()
 	{
 	// local variable for computing total minute
	   int min;

	// get number of minutes from dividing
	// 60 seconds and add to the original minutes
	   min =(int) Math.floor(totalSec/60);
	   totalMin += min;

 	   return totalMin;
 	}

/**
 * Get Total seconds of the CD
 * total second is set in the addSong method
 * @return: (int) total seconds
 **/
 	public int getTotalSec()
 	{
 	// local variable for computing total second
	   int sec = totalSec;

	// get the reminder of second divided by 60
	   totalSec = sec%60;

 	   return totalSec;
 	}

/**
 * Get a specified Song object from the song array
 * @param: (int) song array index
 **/
 	public Song getSong(int songsArrayIndex)
 	{
 	// get the specified song object in the array
 	   return songs[songsArrayIndex];
 	}

/**
 * Return Artist name
 * @return: (String) artist name of the CD
 **/
  	public String getArtist()
  	{
  		return artist;
  	}

/**
 * Get Matched Song Index number
 **/
 	public int getMatchSongIndex()
 	{
 		return matchSongIndex;
 	}

/******************************************************
	Methods of Adding Songs in CD
 ******************************************************/

/**
 * Add Songs in a CD
 * @param: number of songs in the CD
 */
	public void addSong(BufferedReader stdin,
	                    int numOfSong) throws IOException
	{
	// local variable for computing total minutes
	   int minSum = 0;

	// local variable for computing total seconds
	   int secSum = 0;

	// add all songs to the CD
	   for(int i = 1; i <= numOfSong; i ++)
 	   {
 	   	// get song name
 		   System.out.println
 		   ("Enter song details for song "+ i);
 		   System.out.print("Song name: ");
 		   String songName = stdin.readLine();

 		// get song running time: minutes
 		   System.out.println
 		   ("Enter time details for new song:");
 		   System.out.print("Minutes: ");
 		   int minutes = Integer.parseInt
 		   (stdin.readLine());

 		// ensure minute is between 0-79
 		   while(minutes < 0 || minutes > 79)
 		   {
 		   	 System.out.print
 		   	 ("Invalid entry. Re-enter Minutes: ");
 		   	 minutes = Integer.parseInt
 		   	 (stdin.readLine());
 		   }

 		// get song running time: seconds
 		   System.out.print("Seconds: ");
 		   int seconds = Integer.parseInt
 		   (stdin.readLine());
 		   System.out.println();

 		// ensure seconds is between 0 - 59
 		   while(seconds < 0 || seconds > 59)
 		   {
 		   	 System.out.print
 		   	 ("Invalid entry. Re-enter Seconds: ");
 		   	 seconds = Integer.parseInt
 		   	 (stdin.readLine());
 		   }

 	   	// create a song object
		   Song song = new Song();

		// increase songs index by one
		   songsIndexLast++;

 		// sum the minutes and seconds of songs in the CD
 		   minSum = minSum + minutes;
 		   secSum = secSum + seconds;

 		// set all song's information
		   song.setSongName(songName);
		   song.setSongMins(minutes);
		   song.setSongSecs(seconds);

		// assign song object to the songs array
		   songs[songsIndexLast] = song;
	   }// end for loop

		// set the total min and total sec of the CD
		   totalMin = minSum;
		   totalSec = secSum;
	}

/**
 * Add a specified song to the CD
 * add to the last song array element
 * @param: (String) song name
 *         (int) song time (minutes)
 *         (int) song time (seconds)
 **/
 	public void addSong(String songName, int minutes,
 	  					int seconds) throws IOException
 	{
 	// create a song object
	   Song song = new Song();

	// increase songs index by one
	   songsIndexLast++;

	// set all song's information
	   song.setSongName(songName);
	   song.setSongMins(minutes);
	   song.setSongSecs(seconds);

	   totalMin += minutes;
	   totalSec += seconds;

	// assign song object to the songs array
	   songs[songsIndexLast] = song;
	}

/**
 * Check new number of Song is greater or
 * smaller than the origainal song numbers
 *
 * @param: (int) new number of Song
 * @return: (Boolean) true if it is greater
 *           false if it is smaller
 **/
 	public boolean addSong(int newNumOfSong)
 	{
 	// check the new number of song is more than
 	// the original number of songs
 	   if (newNumOfSong < songsIndexLast+1)
 	   {
 			return false;
 	   }
 	   else if (newNumOfSong == songsIndexLast+1)
 			return false;
 	   else
 			return true;
  	}

/****************************************************************
 	Other Methods
 ****************************************************************/

/**
 * Enlarge the original size of the song array
 * with new number of song
 * @param: (int) new number of songs
 **/
	public void enlarge(int newSongNumber)
	{
	// create a new array with a new size
	   Song[] temp = new Song[newSongNumber];

	// copy the data to the new array
	   for(int i = 0; i < songsIndexLast+1; i++)
	   {
		  temp[i] = songs[i];
	   }

	// set the variable cds to point to the new array
	      songs = temp;
	}

/**
 * Search for song name in a specified CD
 * @param: (String) song name
 *		   (object) a CD object
 * @return: (boolean) true if found. false if not
 **/
    public boolean numOfMatchedSongName(String name, CD cd)
    {
   	// search through all songs in the specified CD
   	   for(int i = 0; i <= songsIndexLast; i++)
   	   {
   			if(name.equals(cd.getSong(i).getSongName()))
   			{
		    // set the index of the
		    // matched song in the variable
   			   matchSongIndex = i;
   			   return true;
   			}
   		}
   		return false;
   	}

/**
 * Remove Song
 * @param: (int) song number
 *         that will be removed
 **/
 	public void removeSong(int index)
 	{
 	// move the element content to the front
 	   for(int i = index; i < songsIndexLast; i++)
 	   {
 			songs[i] = songs[i+1];
 	   }

 	// set the last element to null
 	   songs[songsIndexLast] = null;

 	// decrease the last used index by one
 	   songsIndexLast--;
 	}


/**
 * Display song information in a CD
 **/
	public void displaySongInfo() throws IOException
	{
		for(int i = 0; i <= songsIndexLast; i++)
 	    {
	 	  System.out.print("Song ");
 		  System.out.print(i+1 + ": ");
		  System.out.print(songs[i].getSongName() + ", ");
 		  System.out.print(songs[i].getSongMin() + ":");
 	      System.out.println(songs[i].getSongSec());
 	   	}
 	 }

/**
 * Compute the total time of the CD
 **/
	public void totalTime()
	{
	// local variable for computing the total min and sec
		int min = 0;
		int sec = 0;

	// add every songs' min and sec
		for(int i = 0; i <= songsIndexLast; i++)
		{
			min += songs[i].getSongMin();
			sec += songs[i].getSongSec();
		}

		min = totalMin;
		sec = totalSec;

		System.out.println(totalMin + ":" + totalSec);
	}

/**
 * toString method
 * Display CD information as a String object
 * use to convert information to String
 * purpose: easy to store information to a file
 **/
  	public String toString()
  	{
  	  return (artist+ '|' + title+ '|'+ year + '|'+ numOfSong+'|');
  	}

 }//end class CD