/********************************* to column 80******************************
 Main Class:       CDCollection Class
 Author:           Yannis Lau <yylau2@students.wisc.edu>
 Completion Date:  12-16-99
 Course:           CS 302, Fall '99, Section 311
 TA:               Daniel Tomko
 Assignment:       Project 2

 Compiler:         CodeWarrior (JDK 1.2)
 Platform:         Windows NT 4.0
 ****************************************************************************/
import java.io.*;
import java.util.*;

 /**
  * Represent a CDCollection of CD array and for
  * other classes to use
  *
  * Bugs: none known
  **/

 class CDCollection
 {
/**
 * DATA MEMBERS
 **/

	private final int DEFAULT_SIZE = 10; // cds array initial size
	private CD[] cds;			  // declare cds array
	private int cdsIndexLast;     // prepare for assign song object
								  // to the last empty index element
	private BufferedReader stdin; // use to read input from console
	private int numCD;            // count number of CD in collection
	private int searchArtistFound;// count the result of matched
	                              // artist found
	private int searchTitleFound; // count result of matched title
	private int searchSongNameFound;     // count result of matched
	                                     // song name


/**
 * CONSTRUCTOR
 * Construct:
 *    -CD array and set its size to 10
 *    -CD array index set to -1, use last index
 *    -search artist result set to 0
 *    -search title result set to 0
 *    -number of CD set to 0
 **/

    public CDCollection()
    {
     // cds array initial size
 		cds = new CD[DEFAULT_SIZE];

 	 // make sure to use last index element
 		cdsIndexLast = -1;

 	 // result of search is zero
 		searchArtistFound = 0;

 	 // result of search is zero
 		searchTitleFound = 0;

 	 // result of search is zero
 		searchSongNameFound = 0;

 	 // number of CD in the collection start from zero
 		numCD = 0;
    }

/**
 * Add a CD
 * @param: (String) artist name, title name
 *         (int) year of release, number of songs
 **/

 	public void addCD(BufferedReader stdin)
 					  throws IOException
 	{
 	// increase cds index by one
 	 	cdsIndexLast++;

 	// check if cds array still has space
 	 	if(cdsIndexLast < cds.length)
 	 	{
 	   // get CD information from user
 		  System.out.println("Enter details for new CD:");

 	   // get artist name
 	      System.out.print("Enter artist name: ");
 	      String artist = stdin.readLine();

       // get title name
 	   	  System.out.print("Enter CD title: ");
 	      String title = stdin.readLine();

       // get year of release
 	      System.out.print("Enter year: ");
 	      int year = Integer.parseInt(stdin.readLine());

 	   // ensure number of song is a positive number
 	   	  while(year < 1000 || year > 9999)
 	      {
 	   		System.out.println
 	   		("Invalid entry. Re-enter year: ");
 	   		year = Integer.parseInt(stdin.readLine());
 	      }

       // get number of songs
 	      System.out.print("Enter number of songs: ");
 	      int numOfSong = Integer.parseInt(stdin.readLine());
 	      System.out.println("\n");

 	   // ensure number of song is a positive number
 	   	  while(numOfSong <= 0)
 	   	  {
 	   		System.out.println
 	   		("Invalid entry. Re-enter number of songs: ");
 	   		numOfSong = Integer.parseInt(stdin.readLine());
 	      }

 	   // create a CD object
 		  CD cd = new CD(numOfSong);

	   // set all information about CD
 	 	  cd.setCD(stdin, artist, title, year, numOfSong);

 	   // assign cd object to the cds array
 	 	  cds[cdsIndexLast] = cd;
 	 	}
 	 	else
 	 	{
 	   // double the cds array size
 	 	  enlarge();

 	   // get CD information from user
 		  System.out.println("Enter details for new CD:");

 	   // get artist name
 	      System.out.print("Enter artist name: ");
 	      String artist = stdin.readLine();

       // get title name
 	   	  System.out.print("Enter CD title: ");
 	      String title = stdin.readLine();

       // get year of release
 	      System.out.print("Enter year: ");
 	      int year = Integer.parseInt(stdin.readLine());

 	    // ensure year has 4 digits and greater than 1000
 	   	  while(year < 1000 || year > 9999)
 	      {
 	   		System.out.print
 	   		("Invalid entry. Re-enter Year: ");
 	   		year = Integer.parseInt(stdin.readLine());
 	      }

       // get number of songs
 	      System.out.print("Enter number of songs: ");
 	      int numOfSong = Integer.parseInt(stdin.readLine());

 	   // ensure number of song is a positive number
 	   	  while(numOfSong <= 0)
 	   	  {
 	   		System.out.print
 	   		("Invalid entry. Re-enter number of songs: ");
 	   		numOfSong = Integer.parseInt(stdin.readLine());
 	      }
 	   	  System.out.println();

 	   // create a CD object
 		  CD cd = new CD(numOfSong);

	   // set all information about CD
 	 	  cd.setCD(stdin, artist, title, year, numOfSong);

 	   // assign cd object to the cds array
 	 	  cds[cdsIndexLast] = cd;
 	 	}
 	}

/**
 * Add CD from a file to the memory
 * @param: (String) artist name
 *
 **/
 	public void updateCD(BufferedReader stdin, String artist,
 						 String title, int year, int numOfSong)
 	                     throws IOException
 	{
 	// check if cds array still has space
 	   if(cdsIndexLast < cds.length)
 	   {
 	   // create a CD object
 		  CD cd = new CD(numOfSong);

	   // set all information about CD
 	 	  cd.updateCD(artist, title, year, numOfSong);

 	   // assign cd object to the cds array
 	 	  cds[cdsIndexLast] = cd;
 	   }
 	   else
 	   {
 	   // double the cds array size
 	 	  enlarge();

 	   // create a CD object
 		  CD cd = new CD(numOfSong);

	   // set all information about CD
 	 	  cd.updateCD(artist, title, year, numOfSong);

 	   // assign cd object to the cds array
 	 	  cds[cdsIndexLast] = cd;
 	   }
 	}

/**
 * Double the original size of the cds array
 **/
	public void enlarge()
	{
	// create a new array that is double the original size
	   CD[] temp = new CD[cds.length * 2];

	// copy the data to the new array
	   for(int i = 0; i < cds.length; i++)
	   {
			temp[i] = cds[i];
	   }
	// set the variable cds to point to the new array
	   cds = temp;
	}

/**
 * Delete the new CD
 * set the newly created CD array element to null
 **/
 	public void delete()
 	{
 		cds[cdsIndexLast] = null;
 		cdsIndexLast--;
 	}

/**
 * Remove CD
 * @param: (int) cd index which user want to remove
 * @return: true if remove successfully
 *          false if not
 **/
 	public boolean removeCD(int index)
 	{
 	// move the element content to the front
 		for(int i=index; i<cdsIndexLast; i++)
 		{
 			cds[i] = cds[i+1];
 		}

 	// set the last element to null
 		cds[cdsIndexLast] = null;

 	// decrease the last used index by one
 		cdsIndexLast--;

 	// remove CD successfully
 		return true;
 	}

/**
 * Count the number of CD in the collection
 * @return: (int) number of CDs in the array
 **/
	public int numOfCD()
	{
	// check through the cd array
		for(int i = 0; i < cds.length; i++)
		{
			if(cds[i] != null)
				numCD++;
		}
		return numCD;
	}

/**
 * Make changes to the CD
 * @param: (object) a CD object
 *         (int) index of the original CD
 *               belongs to the cd array
 **/
 	public void setCD(CD tempCD, int index)
 	{
 		cds[index] = tempCD;
 	}

/**
 * Get a specified CD object from the cd array
 * @param: int cd array index
 **/
 	public CD getCD(int cdArrayIndex)
 	{
 	//get the specified cd object in the array
 		return cds[cdArrayIndex];
 	}

/********************************************************************
 	Display CD information methods, one display all CDs information
 	another display a specific CD's information
 ********************************************************************/

/**
 * Display all information in the CD
 **/
 	public void displayCDInfo() throws IOException
 	{
	// display the added CD information to the user
 	   for(int i = 0; i<=cdsIndexLast; i++)
 	   {
 	       System.out.println("New CD details: ");
 	       System.out.println("Artist: "+ cds[i].getArtist());
    	   System.out.println("Title: "+ cds[i].getTitle());
    	   System.out.println("Year: "+ cds[i].getYear());
    	   System.out.print
		   ("Total Time: "+cds[i].getTotalMin());
		   System.out.println
		   (":" + cds[i].getTotalSec());
 	       System.out.println
 	       ("Number of Songs: "+ cds[i].getNumOfSong());
 	   	   cds[i].displaySongInfo();  // use cd class method
 	   	   System.out.println("\n");
 	   }
 	}

/**
 * Display the specified CD information
 * @param: (int) index of the CD which will be display
 **/
 	public void displayCD(int index) throws IOException
 	{
 		System.out.println
 		("Artist: " + cds[index].getArtist());
 		System.out.println
 		("Title: " + cds[index].getTitle());
 		System.out.println
 		("Year: " + cds[index].getYear());
 		System.out.println
 		("Number of Songs: " + cds[index].getNumOfSong());
		System.out.print
		("Total Time: "+cds[index].getTotalMin());
		System.out.println
		(":" + cds[index].getTotalSec());
		System.out.println
		("Number of Songs: " + cds[index].getNumOfSong());
		cds[index].displaySongInfo();  // use cd class method
 	   	System.out.println("\n");
 	 }




/**************************************************************
  Methods of searching by artist name, title, and song name
  and displaying information of the search result
 **************************************************************/

/**
 * Search for artist name
 * @param: (String) artist name
 * @return: (int []) the index of the matched found
 **/
    public int[] searchArtist(String artist)
    {
   	// create a local array for getting the matched index
   	// assume the maximum size is all CD matched

   	   int[] index = new int[cdsIndexLast+1];

   	// make sure the local array starts with the unused element
   	   for(int k = 0; k<=cdsIndexLast; k++)
   	   index[k]=-1;

   	// local variable for the first local array used index
   	   int ind = 0;

   	// local variable for searching through
   	// the CD array elements
   	   int i = 0;

   	// search through the CD array elements
   	   while(i <= cdsIndexLast)
   	   {
   		 	if(artist.equals(cds[i].getArtist()))
   			{
   				index[ind] = i;
   				ind++;
   			}
   			i++;
   		}
   		return index;
    }

/**
 * Search for number of matches of artist name
 * @param: (String) artist name
 * @return: (int) number of the matched found
 **/
    public int numOfMatchedArtist(String artist)
    {
    // assign/ assume the finding is zero
	   searchArtistFound = 0;

   	// local variable for searching through the CD array elements
   	   int i = 0;

   	// search through the CD array elements
   	   while(i <= cdsIndexLast)
   	   {
   			if(artist.equals(cds[i].getArtist()))
   			{
   			// increment by 1 if same artist name is found
   			   searchArtistFound++;
   			}
   			i++;
   		}
   		return searchArtistFound;
   	}

/**
 * Display CD information of the matched artist name
 * @param: (int[]) the matched index array that
 *         searched by searchArtist method
 **/
 	public void displayMatchArtistInfo(int[] index)
 	                                   throws IOException
 	{
 	// display all information about the CD(s)
 	   for(int i = 0; i < searchArtistFound; i++)
 	   {
 			System.out.print("#### Match ");
 			System.out.print(i+1);
 			System.out.println(" ####");
 			System.out.println
 			("Artist: " + cds[index[i]].getArtist());
 			System.out.println
 			("Title: " + cds[index[i]].getTitle());
 			System.out.println
 			("Year: " + cds[index[i]].getYear());
 			System.out.print
			("Total Time: "+cds[index[i]].getTotalMin());
			System.out.println
			(":" + cds[index[i]].getTotalSec());
			System.out.println("\n");
		}
	}

/**
 * Search for CD title
 * @param: (String) CD title
 * @return: (int []) the index of the matched found
 **/
    public int[] searchTitle(String title)
    {
   	// create a local array for getting the matched index
   	// assume the maximum size is all CD matched
   	   int[] index = new int[cdsIndexLast+1];

   	// make sure the index start with an unused element
   	   for(int k = 0; k<=cdsIndexLast; k++)
   	   index[k]=-1;

   	// local variable for the first local array used index
   	   int ind = 0;

   	// local variable for searching through
   	// the CD array elements
   	   int i = 0;

   	// search through the CD array elements
   	   while(i <= cdsIndexLast)
   	   {
   			if(title.equals(cds[i].getTitle()))
   			{
   			// assign the local array with the CD array
   			// index number
   			   index[ind] = i;
   			   ind++;
   			}
   			i++;
   		}
   		return index;
    }

/**
 * Search for number of matches of CD title
 * @param: (String) CD title
 * @return: (int) number of the matched found
 **/
    public int numOfMatchedTitle(String title)
    {
    // assign/ assume the search title found is zero
	   searchTitleFound = 0;

   	// local variable for searching through
   	// the CD array elements
   	   int i = 0;

   	// search through the CD array elements
   	   while(i <= cdsIndexLast)
   	   {
   			if(title.equals(cds[i].getTitle()))
   			{
   			// if same title is found, increment by one
   			   searchTitleFound++;
   			}
   			i++;
   		}
   		return searchTitleFound;
   	}

/**
 * Display CD information of the matched CD title
 * @param: (int[]) the matched index array that
 *         searched by searchTitle method
 **/
 	public void displayMatchTitleInfo(int[] index)
 	                                  throws IOException
 	{
 	 // display all information about the CD(s)
 	   	for(int i = 0; i < searchTitleFound; i++)
 		{
 			System.out.print("#### Match ");
 			System.out.print(i+1);
 			System.out.println(" ####");
 			System.out.println
 			("Artist: " + cds[index[i]].getArtist());
 			System.out.println
 			("Title: " + cds[index[i]].getTitle());
 			System.out.println
 			("Year: " + cds[index[i]].getYear());
			System.out.print
			("Total Time: "+cds[index[i]].getTotalMin());
			System.out.println
			(":" + cds[index[i]].getTotalSec());
			System.out.println
			("Number of Songs: " + cds[index[i]].getNumOfSong());
			//use CD class method
			cds[index[i]].displaySongInfo();
			System.out.println("\n");
		}
	}

/**
 * Search for song name
 * @param: (String) song name
 * @return: (int []) the index of the CDs
 *          that contain the matched song
 **/
    public int[] searchSongName(String name)
    {
   	// create a local array for getting the matched CD index
   	// assume the maximum size is all CD matched
   	   int[] index = new int[cdsIndexLast+1];

   	// make sure the local array starts with the unused element
   	   for(int k = 0; k<=cdsIndexLast; k++)
   	   index[k]=-1;

   	// local variable for the first local array used index
   	   int ind = 0;

   	// local variable for searching through
   	// the CD array elements
   	   int i = 0;

   	// search through the CD array elements
   	   while(i <= cdsIndexLast)
   	   {
   	   // search every song in the CD using
   	   // numOfMatchedSongName method
   		  if(cds[i].numOfMatchedSongName(name, cds[i]))
   		  {
   		  // if song found in the CD, assign the CD's index
   		  // in the local array
   			 index[ind] = i;

   		  // increment the local array index by 1
   			 ind++;
   		  }
   	   // increment the CD index by one to search
   	   // in another CD
   		  i++;
   		}
   		return index;
    }

/**
 * Search for number of matches of song name
 * <assume no song name appears twice or more in a CD>
 * @param: (String) song name
 * @return: (int) number of the matched found
 **/
    public int numOfMatchedSongName(String name)
    {
    // assign/assume the search song name found is zero
	   searchSongNameFound = 0;

   	// local variable for searching through
   	// the CD array elements
   	   int i = 0;

   	// search through the CD array elements
   	   while(i <= cdsIndexLast)
   	   {
   			if(cds[i].numOfMatchedSongName(name, cds[i]))
   			{
   			// if same song name is found, increment by one
   			   searchSongNameFound++;
   			}
   			i++;
   		}
   		return searchSongNameFound;
   	}

/**
 * Display CD information of the matched song name
 * @param: (int[]) the matched index array that
 *         searched by searchSongName method
 **/
 	public void displayMatchSongNameInfo(int[] index)
 	                                     throws IOException
 	{
 	// display all information about the CD(s)
 	   for(int i = 0; i < searchSongNameFound; i++)
 	   {
 			System.out.print("#### Match ");
 			System.out.print(i+1);
 			System.out.println(" ####");
 			System.out.println
 			("Artist: " + cds[index[i]].getArtist());
 			System.out.println
 			("Title: " + cds[index[i]].getTitle());
 			System.out.println
 			("Year: " + cds[index[i]].getYear());
			System.out.print
			("Total Time: "+cds[index[i]].getTotalMin());
			System.out.println
			(":" + cds[index[i]].getTotalSec());
			System.out.print
			("Song: " + cds[index[i]].getSong
			(cds[index[i]].getMatchSongIndex()).getSongName());
			System.out.print(", ");
			System.out.print
			(cds[index[i]].getSong
			(cds[index[i]].getMatchSongIndex()).getSongMin());
			System.out.print(":");
			System.out.println
			(cds[index[i]].getSong
			(cds[index[i]].getMatchSongIndex()).getSongSec());
			System.out.println("\n");
		}
	}

/****************************************************************
   	Modify Methods
 ****************************************************************/

/**
 * Change Artist name
 * @param: (object) a CD object
 *         (int) a specified CD index
 **/
 	private void changeArtist(BufferedReader stdin, CD tempCD,
 	                         int tempCDIndex) throws IOException
 	{
 	 // get new artist name from user
 		System.out.print("Enter Artist Name: ");
 	  	String newArtist = stdin.readLine();

 	 // change artist name
 	    tempCD.setArtist(newArtist);

 	 // set the tempCD with new info to
 	 // the original CD
 	    setCD(tempCD, tempCDIndex);

 	 // display CD info with new changes
        displayCD(tempCDIndex);
    }

/**
 * Change CD Title
 * @param: (object) a CD object
 *         (int) a specified CD index
 **/
 	private void changeTitle(BufferedReader stdin, CD tempCD,
 	                        int tempCDIndex) throws IOException
 	{
 	 // get new Title from user
 		System.out.print("Enter Title Name: ");
 		String newTitle = stdin.readLine();

     // change title name
        tempCD.setTitle(newTitle);

     // set the tempCD with new info to
     // the original CD
        setCD(tempCD, tempCDIndex);

 	 // display CD info with new changes
    	displayCD(tempCDIndex);
    }

/**
 * Change Year of Release
 * @param: (object) a CD object
 *         (int) a specified CD index
 **/
    private void changeYear(BufferedReader stdin, CD tempCD,
                           int tempCDIndex) throws IOException
    {
    // get new year from user
       System.out.print("Enter Year: ");
 	   int newYear = Integer.parseInt(stdin.readLine());
       System.out.println("\n");

    // ensure year has 4 digits
 	   while(newYear < 1000 || newYear > 9999)
 	   {
 	      System.out.print
 	   	  ("Invalid entry. Re-enter Year: ");
 	   	  newYear = Integer.parseInt(stdin.readLine());
 	   }

    // change year of release
       tempCD.setYear(newYear);

    // set the tempCD with new info to
    // the original CD
       setCD(tempCD, tempCDIndex);

    // display CD info with new changes
       displayCD(tempCDIndex);
    }

/**
 * Change Number of Songs (Adding)
 * @param: (object) a CD object
 *         (int) a specified CD index
 *         (int) new number of songs
 **/
    private void changeNumSongAdd(BufferedReader stdin,
    							  CD tempCD, int tempCDIndex,
    							  int newNumOfSong)
                                  throws IOException
    {
    // count number of Songs to add
   	   int count;
   	   count = newNumOfSong - tempCD.getNumOfSong();

   	// change number of songs
   	   tempCD.setNumOfSong(newNumOfSong);

   	// set the tempCD with new info to the original CD
	   setCD(tempCD, tempCDIndex);

    // enlarge the song array to store the new songs
       tempCD.enlarge(newNumOfSong);

    // get information about the new songs
	   for(int s = 0; s < count; s++)
       {
	   // get song name
 		  System.out.println
 		  ("Enter song details for song ");
		  System.out.print("Song name: ");

		  String newSongName = stdin.readLine();

	   // get song running time: minutes
	   	  System.out.println
	   	  ("Enter time details for new song:");

 		  System.out.print("Minutes: ");
		  int newSongMin = Integer.parseInt
		  (stdin.readLine());

	   // ensure minutes is a positive number
 	   	  while(newSongMin < 0 || newSongMin > 79)
 	   	  {
 	   		System.out.print
 	   		("Invalid entry. Re-enter Minutes: ");
 	   		newSongMin = Integer.parseInt(stdin.readLine());
 	      }

	   // get song running time: seconds
		  System.out.print("Seconds: ");

	      int newSongSec = Integer.parseInt
	      (stdin.readLine());
	      System.out.println();

	   // ensure seconds is a positive number
 	   	  while(newSongSec < 0 || newSongSec > 59)
 	   	  {
 	   		System.out.print
 	   		("Invalid entry. Re-enter Seconds: ");
 	   		newSongSec = Integer.parseInt(stdin.readLine());
 	      }
 	      System.out.println("\n");

	   // add the new song information to the CD
	      tempCD.addSong
	      (newSongName, newSongMin, newSongSec);

	   }// end for loop

	 // set the tempCD with new info to the original CD
   	    setCD(tempCD, tempCDIndex);

	 // display CD info with new changes
	    displayCD(tempCDIndex);
     }

/**
 * Change Number of Songs (Removing)
 * @param: (object) a CD object
 *         (int) a specified CD index
 *         (int) new number of songs
 **/
	private void changeNumSongRemove(BufferedReader stdin,
	 								 CD tempCD, int tempCDIndex,
	 								 int newNumOfSong)
	                                 throws IOException
	{
	// count how many songs to remove
   	   int count;
   	   count = newNumOfSong - tempCD.getNumOfSong();

	// change number of songs
   	   tempCD.setNumOfSong(newNumOfSong);

   	// set the tempCD with new info to the original CD
   	   setCD(tempCD, tempCDIndex);

    // remove the songs that are too much
       for(int r = 0; r < (-count); r++)
	   {
	   	  System.out.print("Enter song number to remove: ");
      	  int remove = Integer.parseInt(stdin.readLine());

       // remove a specified song
          tempCD.removeSong(remove-1);
     	  System.out.println("Remove Success");
	   }

	// set the tempCD with new info to the original CD
	   setCD(tempCD, tempCDIndex);

	// display CD info with new changes
	   displayCD(tempCDIndex);
	   System.out.println("\n");
    }

/**
 * Change A Song
 * @param: (object) a CD object
 *         (int) a specified CD index
 *         (int) new number of songs
 **/
 	private void changeASong(BufferedReader stdin, CD tempCD,
 							int tempCDIndex) throws IOException
 	{
 	// display all songs info
   	   tempCD.displaySongInfo();
 	   System.out.println("\n");

    // get new number of songs
       System.out.print("Enter the song number to change: ");
       int numofSong = Integer.parseInt(stdin.readLine());
       System.out.println("\n");

    // get the specified song object
       tempCD.getSong(numofSong-1);

    // get song name
 	   System.out.println("Enter song details for song ");
       System.out.print("Song name: ");
	   String newSongName = stdin.readLine();

	// get song running time: minutes
	   System.out.println("Enter time details for new song:");
       System.out.print("Minutes: ");
	   int newSongMin = Integer.parseInt(stdin.readLine());

	// get song running time: seconds
	   System.out.print("Seconds: ");
	   int newSongSec = Integer.parseInt(stdin.readLine());
	   System.out.println();

	// change the song information in the CD
    // first get the specified song object
	// then, change the song name, min and sec
	   tempCD.getSong(numofSong-1).setSongName(newSongName);

	   tempCD.getSong(numofSong-1).setSongMins(newSongMin);

	   tempCD.getSong(numofSong-1).setSongSecs(newSongSec);

	// set the tempCD with new info to the original CD
	   setCD(tempCD, tempCDIndex);

	// display CD info with new changes
	   displayCDInfo();
	   System.out.println("\n");
	}

/*********************************************************************
	Modify Menu: user selection of Change artist, title, year,
	number of songs, or change a song.
	Make those changes by using other private methods
 *********************************************************************/

/**
 * Modify Menu and the selections
 * @param: (object) a CD object
 *         (int) a specific CD index
 *         (int) user's choice
 **/
	public void modifySelection(BufferedReader stdin, CD tempCD,
	 							int tempCDIndex, int choice)
	 							throws IOException
	{
    // user selection
	   switch(choice)
 	   {
       // Change Artist is selected
          case 1:
            changeArtist(stdin, tempCD, tempCDIndex);
  	      break;

 	   // Change Title is selected
          case 2:
 	         changeTitle(stdin, tempCD, tempCDIndex);
    	     break;

       // Change Year of Release is selected
 	      case 3:
 	        changeYear(stdin, tempCD, tempCDIndex);
 			break;

       // Change Number of Songs is selected
   	      case 4:
   	      // display all songs info
   	         tempCD.displaySongInfo();
 	   	   	 System.out.println("\n");

   	   	  // get new number of songs
   	         System.out.print("Enter new number of song: ");
 		     int newNumOfSong = Integer.parseInt
 		     (stdin.readLine());
  		     System.out.println("\n");

  		  // song number should be greater than zero
	   		 while(newNumOfSong <= 0)
	   		 {
	   	  		System.out.println
	   	  		("Invalid entry. Re-enter number of Songs: ");
	   	  		newNumOfSong = Integer.parseInt
	   	  		(stdin.readLine());
	   		 }

  	      // check if the user want to add or remove song
   	         if(tempCD.addSong(newNumOfSong))
   	         {
   	            changeNumSongAdd
   	            (stdin, tempCD, tempCDIndex, newNumOfSong);
   	         }

   	      // if user want to remove song
		     else
			 {
			    changeNumSongRemove
			    (stdin, tempCD, tempCDIndex, newNumOfSong);
			 }
			 break;

       // Change a Song is selected
 	      case 5:
 	         changeASong(stdin,tempCD,tempCDIndex);
 	         break;

 	   // Exit and Return to Main Menu is selected
 	      case 6:
 			 break;

 		  default: break;
 		  }//end switch(choice4) selection of Modify Menu
	}// end modify

/******************************************************************
   Load and Save File Methods
 ******************************************************************/

/**
 * Load data from a file
 **/
 	public void loadFile(BufferedReader stdin)
 						 throws IOException
 	{
 	 // declare the object variables
 		File srcFile;

 	 // First the user enters the path of
 	 // the source file, which must be a valid
     // file for the loop to end.
     // assume a valid file is entered on the first try
        boolean repeat = false;

        do {
              System.out.print
              ("Enter the path of the source file: ");

           // create File object
              srcFile = new File(stdin.readLine());

           // check if source file doesn't exist
              if(!srcFile.exists())
              {
                System.out.println("ERROR: file not found");
                repeat = true;
              }
           // check if source file isn't a file or not readable
              else if(!srcFile.isFile() ||
                      !srcFile.canRead())
              {
                System.out.println
                ("ERROR: file not readable");
                repeat = true;
              }
              else
                repeat = false;
            } while (repeat);

           // create a BufferedReader object to read file
              BufferedReader inFile = new BufferedReader
              (new FileReader(srcFile));

           // check if the file is reached the end
              while (inFile.ready())
              {
             // readLine method reads an entire line
                String line = inFile.readLine();

             // StringTokenizer object is created
                StringTokenizer tokenizer;
                tokenizer = new StringTokenizer(line, "|");

                while(tokenizer.hasMoreTokens())
                {
               // increment cds array index by 1
               // to store the CD from index 0
               	  cdsIndexLast++;

               // read the artist of the CD
              	  String names = tokenizer.nextToken();

               // read the title of the CD
              	  String titleCD = tokenizer.nextToken();

               // read the year of the CD
              	  int yr = Integer.parseInt
              	  (tokenizer.nextToken());

               // read number of songs in the CD
                  int songs = Integer.parseInt
                  (tokenizer.nextToken());

               // update loaded CD information
              	  updateCD(stdin, names, titleCD, yr, songs);

               // display
                  System.out.println
                  ("Name: " + names);
                  System.out.println
                  ("Year: " + yr);
                  System.out.println
                  ("Title:  " + titleCD);
                  System.out.println
                  ("NumOfSong: " + songs);

               // local variable to read the minute and second
                  int minute, second;

               // local variable to count the total min and sec
                  int minSum = 0;
                  int secSum = 0;

               // read the song name and time
                  for(int i = 0; i < songs; i++)
                  {
                 // display song name
					String songName = tokenizer.nextToken();
					System.out.print
					("Song Name: " + songName + ", ");

				 // read the minutes and seconds with the ":"
				 // as a String
					String time = tokenizer.nextToken()+':';

				 // create a new tokenizer to read the minute
				 // and second separately
					StringTokenizer tokenizer2;
					tokenizer2 = new StringTokenizer(time,":");

				 // covert to integer minute and second
					minute = Integer.parseInt
					(tokenizer2.nextToken());
				    second = Integer.parseInt
				    (tokenizer2.nextToken());

				 // add every song minutes and seconds
				    minSum += minute;
				    secSum += second;

				 // set songs in the CD collection
				 	cds[cdsIndexLast].setSong
				 	(songName, minute, second);

				 // set total time in the CD collection
				    cds[cdsIndexLast].setTotalMin(minSum);
				    cds[cdsIndexLast].setTotalSec(secSum);

                 // display song minute and second
                    System.out.println
                    (", " + minute + ":" + second);
                  }// end for loop

                   System.out.println("\n");
                }//end finding Tokens
             }//end reading file

             inFile.close();
       }// end load file method

/**
 * Write data to a file
 **/
 	public void writeFile(BufferedReader stdin)
 						  throws IOException
 	{
 	// declare the object variables
 	   File dstFile;

 	// ask user to enters the path of the destination file,
 	// which must be a valid file for the loop to end.
 	// assume a valid file is entered on the first try
       boolean repeat = false;

       do{
         System.out.print
         ("Enter the path of the destination file: ");

  	  // create the File object
         dstFile = new File(stdin.readLine());

      // check that if desination file already exists
      // that it is writeable
         if (dstFile.exists() && (dstFile.isDirectory() ||
             !dstFile.canWrite()))
         {
            System.out.println
            ("ERROR: file not writeable");
            repeat = true;
         }
         else
         {
            repeat = false;
         }
       } while (repeat);

    // confirm with user
       System.out.print("Overwrite file? [Y/N]: ");
       String y = stdin.readLine();
       System.out.println("\n");

 	   if(y.equalsIgnoreCase("y"))
       {
       // create PrintWriter object to write data to file
          PrintWriter outFile = new PrintWriter
          (new BufferedWriter(new FileWriter(dstFile)));

       // write file
       // first write the CD information
	      for(int i = 0; i <= cdsIndexLast; i++)
	      {
	        outFile.println(getCD(i).toString());

	     // write all songs from the CD to file
	        for(int s = 0; s < cds[i].getNumOfSong(); s++)
	        {
	           outFile.print(getCD(i).getSong(s).toString());
	        }
	      }
	    // close the file
  	       outFile.close();

	    // display result to user
	       System.out.println("File Saved");
	       System.out.println("\n");
	    }// end if user confirm to store

    }// end save file method
 }//end class CDCollection