/*******************************************************************************

Program:          CD Library

Author:           Yannis Lau  <yylau2@students.wisc.edu
Collaborators:    none

Due Date:         Friday, December 17th, 5:00 pm
Completion Date:  12-16-99
Course:           CS 302, Fall '99, Section 311
TA:               Daniel Tomko
Assignment:       Project 2

Compiler:         CodeWarrior (JDK 1.2)
Platform:         Windows NT 4.0


<--------------Code should not be any wider than this line--------------------->
*******************************************************************************/
import java.io.*;
import java.util.*;

/**
 * Class CDLibrary
 * A class to handle the File I/O, Console I/O, BufferedReader, PrintWriter
 * Represent the CD objects
 *
 * Bugs:
 **/

class CDLibrary
{
  public static void main(String args[]) throws IOException
  {
 // create a menu object
 	Menu menu = new Menu();

 // create a CD Collection object
    CDCollection cdColl = new CDCollection();

 // create a BufferedReader object for console input
    BufferedReader stdin = new BufferedReader
    (new InputStreamReader(System.in));

 // describe the program to user
    menu.describeProgram(stdin);

 // start the program of storing CD if the user is ready
  	System.out.println
   	("Are you ready to store your CD(s) now? y/n:");
 	String s = stdin.readLine();
 	System.out.println("\n\n");

    if(s.equalsIgnoreCase("y"))
 	{
   // redisplay the Main Menu unless Exit is chosen
 	  boolean redisplay = true;
 	  do{
 	  // show Main Menu
 	  	 menu.mainMenu();

 	  // read the number by converting from String to primitive type
 		 int choice1 = Integer.parseInt(stdin.readLine());
 		 System.out.println("\n");

 	  // User Selection
 		 switch(choice1)
 		 {
// Add CD is selected
 		  case 1:
 		     // add CD to CDCollection
 		        cdColl.addCD(stdin);

 		     // display the added CD information to the user
    	        cdColl.displayCDInfo();

 	         // ask user want to add CD
    		    System.out.println("Add new CD? [Y or N]: ");
	    	    String z = stdin.readLine();
    			System.out.println("\n");

   	   	     // check if the user really want to add CD
    		 // it not, delete the newly created CD
    	        if(!(z.equalsIgnoreCase("y")))
    	        {
    	          cdColl.delete();
    	        }

 	  	     // redisplay the Main Menu unless Exit is chosen
 	 	  	    redisplay = true;
 			    break; // break case 1 of the Main Menu

// Remove CD is selected
          case 2:
 		     // show Lookup Menu
 		        menu.lookUpMenu();

	  	     // read number by converting from
	  	     // String to primitive type
 		   	    int choice2 = Integer.parseInt
 		   	    (stdin.readLine());
 		     // user selection
 		   	    switch(choice2)
                {
           		// Lookup by Artist is selected
               	   case 1:
 			       // ask user for the artist name
 			  	      System.out.print("Enter artist name: ");
	 			      String a = stdin.readLine();

    			   // when search result is zero
    			   // display the search result to the user
 			          if(cdColl.numOfMatchedArtist(a) == 0)
 			  	      {
 			  	        System.out.println
 				        ("Number of matches is 0");
 				        System.out.println("\n");
 				      }

 			       // when search result is one
 			       // remove the CD
 			          else if(cdColl.numOfMatchedArtist(a) == 1)
 			          {
 			            cdColl.removeCD(cdColl.searchArtist(a)[0]);
 			            System.out.println("Remove Success");
 			            System.out.println("\n");
 			          }

 			      // when search result is more than one
 			  	      else
 			  	      {
 			  	     // display the number of matches
 			  	        System.out.print("Number of matches is ");
 				        System.out.println
 				        (cdColl.numOfMatchedArtist(a));
 				        System.out.println("\n");

 				     // display info of the CDs found
 				        cdColl.displayMatchArtistInfo
 				        (cdColl.searchArtist(a));

 				     // ask user for which CD to remove
 				        System.out.print
 				        ("Enter match number to remove: ");
 				        int index = Integer.parseInt
 				        (stdin.readLine());
 				        System.out.print("\n");

 				     // remove CD
 				     // index -1 since zero-based index
 				        cdColl.removeCD
 				        (cdColl.searchArtist(a)[index-1]);
 				        System.out.println("Remove Success");
 				        System.out.println("\n");
 				      }
 			 	      break; // break case 1

 		        // Lookup by CD Title is selected
                   case 2:
 			       // ask user for the CD title
 				      System.out.print("Enter CD title: ");
 					  String b = stdin.readLine();

 			  	   // when search result is zero
   			       // display the search result to the user
 			  	 	  if(cdColl.numOfMatchedTitle(b) == 0)
 			  	 	  {
 			  	    	System.out.println
	 				    ("Number of matches is 0");
 					    System.out.println("\n");
 				  	  }

	 			   // when search result is one
 				   // remove the CD
 			          else if(cdColl.numOfMatchedTitle(b) == 1)
 			          {
 			            cdColl.removeCD(cdColl.searchTitle(b)[0]);
		 			    System.out.println
 				        ("Remove Success");
 				        System.out.println("\n");
 			     	  }

 			       // when search result is more than one
 			  	      else
 			  	      {
 			  	   		System.out.print
	 				   	("Number of matches is ");
 					   	System.out.println
 					   	(cdColl.numOfMatchedTitle(b));
 					   	System.out.println("\n");

	 			     // display info of the CDs found
 					    cdColl.displayMatchTitleInfo
 				   	    (cdColl.searchTitle(b));

	 			     // ask user for which CD to remove
 					    System.out.print
 					    ("Enter match number to remove: ");
 					    int index = Integer.parseInt
 				   	    (stdin.readLine());
 				        System.out.print("\n");

	 			     // remove CD
 				     // index -1 since zero-based index
 				        cdColl.removeCD
 				        (cdColl.searchTitle(b)[index-1]);
 				        System.out.println("Remove Success");
 				        System.out.println("\n");

 				      } // end search result more than 1

		 			  break;// break case 2

 			    // Lookup by Song Name is selected
                   case 3:
 				   // ask user for the song name
 				 	  System.out.print("Enter CD Song Name: ");
 				 	  String c = stdin.readLine();

  	 			   // when search result is zero
 				   // display the search result to the user
 				      if(cdColl.numOfMatchedSongName(c) == 0)
		  		  	  {
	 				    System.out.println
 						("Number of matches is 0");
 				   		System.out.println("\n");
 				      }

	 			   // when search result is one
	 			   // remove the CD
 			    	  else if(cdColl.numOfMatchedSongName(c) == 1)
 			     	  {
 			       		cdColl.removeCD
 			       		(cdColl.searchSongName(c)[0]);
		 			    System.out.println
 				        ("Remove Success");
 				        System.out.println("\n");
 			    	  }

	 			   // when search result is more than one
 				  	  else
 				  	  {
 				  	    System.out.print
 					    ("Number of matches is ");
 				   	  	System.out.println
	 				   	(cdColl.numOfMatchedSongName(c));
 					   	System.out.println("\n");

 				   	 // display info of the CDs found
 				    	cdColl.displayMatchSongNameInfo
	 				    (cdColl.searchSongName(c));

 				     // ask user for which CD to remove
 				   	 	System.out.print
	 				    ("Enter match number to remove: ");
 					    int index = Integer.parseInt
 					    (stdin.readLine());
 					    System.out.print("\n");

	 				 // remove CD
 					 // index -1 since zero-based index
 					    cdColl.removeCD
 					    (cdColl.searchSongName(c)[index-1]);
 					    System.out.println("Remove Success");
 					    System.out.println("\n");
 				 	  }// end if more than 1 if found

		 			  break;// break case 3 (look up by song name)
		 			  default: break;
                }//end selection of Lookup Menu
                redisplay = true;
 			    break; // break case 2 of the Main Menu

// Modify CD is selected
 		   case 3:
 		   // show LookUp Menu
 		      menu.lookUpMenu();

 		   // read the number by converting from
 		   // String to primitive type
 			  int choice3 = Integer.parseInt(stdin.readLine());

 		   // user selection
 			  switch(choice3)
 			  {
 		     // Lookup by Artist is selected
 			    case 1:
 			    // ask user for the artist name
 		  	       System.out.print("Enter artist name: ");
 			       String a = stdin.readLine();

 			    // when search result is zero
 			    // display the search result to the user
 			  	   if(cdColl.numOfMatchedArtist(a) == 0)
 			  	   {
 			  	     System.out.println
 				     ("Number of matches is 0");
   				     System.out.println("\n");
 				   }

 			    // when search result is one
 			       else if(cdColl.numOfMatchedArtist(a) == 1)
 			       {
 			      // display the match number of found
 			         System.out.print
 				     ("Number of matches is ");
 				     System.out.println
 				     (cdColl.numOfMatchedArtist(a));
 				     System.out.println("\n");

 			      // display info of the CDs found
 				     cdColl.displayCD
 				     (cdColl.searchArtist(a)[0]);
 				     System.out.println("\n");

 			      // create a temp CD object to store the CD found
 				     CD tempCD = new CD();

 			      // assign the tempCD to the CD that
 			      // the user want to modify
 			 	     tempCD = cdColl.getCD
 			 	     (cdColl.searchArtist(a)[0]);

			      // get the index of the CD object for later use
				     int tempCDIndex = cdColl.searchArtist(a)[0];

				   // redisplay Modify Menu until user choose Exit
 				     boolean showModify = true;
 				     while(showModify)
 				     {
 			        // show Modify selection Menu
 			           menu.modifyMenu();

 			        // read the number by converting String
 			        // to primitive type
			           int choice4 = Integer.parseInt
			           (stdin.readLine());
			           System.out.println("\n");

 			        // check if user choose Exit
 			           if(choice4 != 6)
 			   	       {
     			      // modify CD
     			         cdColl.modifySelection
 			             (stdin, tempCD, tempCDIndex, choice4);
 			           }
 			           else
 			           	 showModify = false;
 			          }// end while loop (show Modify Menu)

			      // redisplay the Main Menu
 			         redisplay = true;
 				   }// end if matched artist is one

 			    // when search result is more than one
 			       else
 			       {
 			      // display the matched number found
 			         System.out.print
 				     ("Number of matches is ");
 				     System.out.println
 				     (cdColl.numOfMatchedArtist(a));
 				     System.out.println("\n");

 			      // display info of the CDs found
 				     cdColl.displayMatchArtistInfo
 				     (cdColl.searchArtist(a));

 			      // ask user for which CD to modify
 			  	     System.out.print
 				     ("Enter match number to modify: ");
 				     int ind = Integer.parseInt
 				     (stdin.readLine());
 				     System.out.print("\n");

 			      // display CD info
 			         cdColl.displayCD
 			         (cdColl.searchArtist(a)[ind-1]);

 			         System.out.println("\n");

 			      // create a temp CD object to store the CD found
 				     CD tempCD = new CD();

 			      // assign the tempCD to the CD
 			      // that user want to modify
 			 	     tempCD = cdColl.getCD
 			 	     (cdColl.searchArtist(a)[ind-1]);

			      // get the index of the CD object for later use
				     int tempCDIndex = cdColl.searchArtist(a)[ind-1];

				  // redisplay Modify Menu until user choose Exit
 				     boolean showModify = true;
 				     while(showModify)
 				     {
			        // show Modify selection Menu
 			   	       menu.modifyMenu();

 			        // read the number by converting String
 			        // to primitive type
			           int choice0 = Integer.parseInt
			           (stdin.readLine());
 			   	       System.out.println("\n");

 			        // check if user choose Exit
 			           if(choice0 != 6)
 			   	       {
     			      // modify CD
     			         cdColl.modifySelection
 			             (stdin, tempCD, tempCDIndex, choice0);
 			           }
 			      	   else
 			      	     showModify = false;
 			      	 }// end while loop (show Modify Menu)

 			      // redisplay the Main Menu
 			         redisplay = true;
 			 	   }// end if more than one artist is found

 			 	   break; // end case 1 (look up by artist)

 		   // Lookup by CD Title is selected
 			  case 2:
 			      // ask user for the CD title
 			         System.out.print("Enter CD title: ");
 			         String b = stdin.readLine();

 				  // when search result is zero
 				  // display the search result to the user
 			 	     if(cdColl.numOfMatchedTitle(b) == 0)
 			 	     {
 			  		    System.out.println
 					    ("Number of matches is 0");
 					    System.out.println("\n");
 			  	     }

 				  // when search result is one
 			 	     else if(cdColl.numOfMatchedTitle(b) == 1)
 			 	     {
 			 	    // display info of the CDs found
 					   cdColl.displayMatchTitleInfo
 					   (cdColl.searchTitle(b));
 					   System.out.println("\n");

 			        // create a temp CD object to store the CD found
 				       CD tempCD = new CD();

 			     	// assign the tempCD to the CD that
 			   		// the user want to modify
 			 		   tempCD = cdColl.getCD
 			 		   (cdColl.searchTitle(b)[0]);

			     	// get the index of the CD object for later use
					   int tempCDIndex = cdColl.searchTitle(b)[0];

 			        // redisplay Modify Menu unless user
 			        // choose Exit
 				       boolean showModify = true;
 				       while(showModify)
 				       {
 			   	      // show Modify selection Menu
 			   		     menu.modifyMenu();


 			  	      // read the number by converting String
 			  	      // to primitive type
			   		     int choice5 = Integer.parseInt
			   		     (stdin.readLine());
			   		     System.out.println("\n");

 			   	      // check if user choose Exit
 			    	     if(choice5!=6)
 			   	         {
 			   	        // modify CD
 			               cdColl.modifySelection
 			               (stdin, tempCD, tempCDIndex, choice5);
 			             }
 			             else
 			             	showModify = false;
 			           }// end while loop (show Modify Menu)

			        // show the Main Menu
 			           redisplay = true;
 			         }// end if matched artist is one

 			      // when search result is more than one
 			         else
 			         {
    			    // display the matched number found
 	    		       System.out.print
 		    		   ("Number of matches is ");
 			    	   System.out.println
 				       (cdColl.numOfMatchedTitle(b));
 				       System.out.println("\n");

    		 	    // display info of the CDs found
 	    			   cdColl.displayMatchTitleInfo
 		    		   (cdColl.searchTitle(b));

    			    // ask user for which CD to modify
 	    			   System.out.print
 		    		   ("Enter match number to modify: ");
    				   int ind = Integer.parseInt
 	    			   (stdin.readLine());
 		    		   System.out.print("\n");

 			        // display CD info
     			       cdColl.displayCD
 	    		       (cdColl.searchTitle(b)[ind-1]);
 		    	       System.out.println("\n");

     			    // create a temp CD object to store the CD found
 	     			   CD tempCD = new CD();

 		    	    // assign the tempCD to the CD
 		    	    // that user want to modify
 			     	   tempCD = cdColl.getCD
     			 	   (cdColl.searchTitle(b)[ind-1]);

	    		    // get the index of the CD object for later use
		    		   int tempCDIndex = cdColl.searchTitle(b)[ind-1];

		    		// redisplay Modify Menu unless user
 				    // choose Exit
 				       boolean showModify = true;
 				       while(showModify)
 				       {
     			      // show Modify selection Menu
 	    		   	     menu.modifyMenu();

 		    	      // read the number by converting String
 		    	      // to primitive type
			   	         int choice12 = Integer.parseInt
			   	         (stdin.readLine());
			   	   		 System.out.println("\n");

			          // check if user choose Exit
 			             if(choice12 != 6)
     			   	     {
 	    		   	    // modify CD
 		    	           cdColl.modifySelection
 			              (stdin, tempCD, tempCDIndex, choice12);
 			             }
 			       		 else
 			       		 	showModify = false;
 			       		}// end while loop (show Modify Menu)
     			 	 }// end if more than one artist is found

 		            // redisplay the Main Menu
 				       redisplay = true;
 				     break; // end case 2 (look up by title)

 		  // Lookup by Song Name is selected
 			 case 3:
 		         // ask user for the song name
 			    	System.out.print("Enter CD Song Name: ");
	 			    String c = stdin.readLine();

 				 // when search result is zero
 		    	 // display the search result to the user
 			    	if(cdColl.numOfMatchedSongName(c) == 0)
	 			    {
 				     System.out.println
 					 ("Number of matches is 0");
 					 System.out.println("\n");
 			    	}

	 			// when search result is one
 				   else if(cdColl.numOfMatchedSongName(c) == 1)
		    	   {
 				  // display the match number of found
  					 System.out.print
	 				 ("Number of matches is ");
 					 System.out.println
 					 (cdColl.numOfMatchedSongName(c));
 					 System.out.println("\n");

 				  // display info of the CDs found
	 			     cdColl.displayMatchSongNameInfo
 				     (cdColl.searchSongName(c));
					 System.out.println("\n");

	 			  // create a temp CD object to store the CD found
 					 CD tempCD = new CD();

 				  // assign the tempCD to the CD that
	 			  // the user want to modify
 				 	 tempCD = cdColl.getCD
 				 	 (cdColl.searchSongName(c)[0]);

				  // get the index of the CD object for later use
				     int tempCDIndex = cdColl.searchSongName(c)[0];

 				  // redisplay Modify Menu unless user
 				  // choose Exit
 				     boolean showModify = true;
 				     while(showModify)
 				     {
	 			    // show Modify selection Menu
 				       menu.modifyMenu();
	 			    // read the number by converting String
	 			    // to primitive type
				   	   int choice6 = Integer.parseInt
				   	   (stdin.readLine());
				   	   System.out.println("\n");

	 		   	    // check if user choose Exit
 				       if(choice6 != 6)
 				   	   {
 				   	  // modify CD
 			    	     cdColl.modifySelection
 			        	 (stdin, tempCD, tempCDIndex, choice6);
 				 	   }
 				 	   else
 				 	 	 showModify = false;
 				 	 }// end while loop (show Modify Menu)
				  // redisplay the Main Menu
 				     redisplay = true;
 				   } // end if song found is 1

 				// if more than 1 song is found
 				   else
 			   	   {
	 			  // display the matched number found
 				     System.out.print
 					 ("Number of matches is ");
 					 System.out.println
 					 (cdColl.numOfMatchedSongName(c));
	 				 System.out.println("\n");

	 			  // display info of the CDs found
	 			     cdColl.displayMatchSongNameInfo
 				     (cdColl.searchSongName(c));
					 System.out.println("\n");

 				  // ask user for which CD to modify
 					 System.out.print("Enter match number to modify: ");
 					 int ind = Integer.parseInt(stdin.readLine());
	 				 System.out.print("\n");

 				  // display CD info
 				     cdColl.displayCD(ind-1);
 			    	 System.out.println("\n");

 				  // create a temp CD object to store the CD found
 					 CD tempCD = new CD();

	 			  // assign the tempCD to the CD that
 				  // the user want to modify
 				 	 tempCD = cdColl.getCD
 			 		 (cdColl.searchSongName(c)[ind-1]);

				  // get the index of the CD object for later use
					 int tempCDIndex = cdColl.searchSongName(c)[ind-1];

 				  // redisplay Modify Menu unless user
 				  // choose Exit
 				     boolean showModify = true;
 				     while(showModify)
 				     {
	 			    // show Modify selection Menu
 				       menu.modifyMenu();

 				    // read the number by converting String
 				    // to primitive type
				   	   int choice7 = Integer.parseInt
				   	   (stdin.readLine());
				   	   System.out.println("\n");

				    // check if the user choose Exit
				       if(choice7!=6)
				       {
 			   		  // modify CD
 			         	 cdColl.modifySelection
	 			         (stdin, tempCD, tempCDIndex, choice7);
	 			       }
	 			       else
	 			     	 showModify = false;
	 			     }// end while loop (show Modify Menu)
 		          }// end if more than one song name is found

	 		   // redisplay the Main Menu unless Exit is chosen
    	 	  	  redisplay = true;
			   }// end switch selection (Modfy CD)
 		 	   break;// break case 3 (Modify CD)

// Lookup CD is selected
     case 4:
 		 // show Lookup Menu
 			menu.lookUpMenu();

 		 // read the number by converting from
 		 // String to primitive type
 			int choice10 = Integer.parseInt
 			(stdin.readLine());

 		 // user selection
 			switch(choice10)
 			{
 		  // Lookup by Artist is selected
 			 case 1:
 		         // ask user for the artist name
 			        System.out.print("Enter artist name: ");
 			        String a = stdin.readLine();

		 		 // when search result is zero
 				 // display the search result to the user
		 			if(cdColl.numOfMatchedArtist(a) == 0)
 					{
		 			  System.out.println
 					  ("Number of matches is 0");
 			    	  System.out.println("\n");
 			  	    }

		 		 // when search result is one or more than one
 			  		else
 			  		{
		 		   // display the number of matches
 			  		  System.out.print
		   			  ("Number of matches is ");
	  				  System.out.println
   				      (cdColl.numOfMatchedArtist(a));
	  				  System.out.println("\n");

	 			   // display info of the CDs found
 				      cdColl.displayMatchArtistInfo
 				      (cdColl.searchArtist(a));
	 				  System.out.println("\n");
 					}

 			  		break;// break case 1 (look up artist)

 		  // Lookup by CD Title is selected
 			 case 2:
 		   		 // ask user for the CD title
 			  		System.out.print("Enter CD title: ");
	 			    String b = stdin.readLine();

	 		     // when search result is zero
 			     // display the search result to the user
 				    if(cdColl.numOfMatchedTitle(b) == 0)
 				    {
		 			  System.out.println
 				      ("Number of matches is 0");
 					  System.out.println("\n");
 			  		}

		 		 // when search result is one or more than one
		 			else
	 			    {
 				   // display number of matches
 				      System.out.print
 					  ("Number of matches is ");
 					  System.out.println
	 				  (cdColl.numOfMatchedTitle(b));
 					  System.out.println("\n");

	 			   // display info of the CDs found
 					  cdColl.displayMatchTitleInfo
 					  (cdColl.searchTitle(b));
	 				  System.out.println("\n");
 					}

 			  		break;// break case 2 (look up title)

 		  // Lookup by Song Name is selected
 			 case 3:
 		  		 // ask user for the song name
	 			    System.out.print("Enter CD Song Name: ");
 				    String c = stdin.readLine();

	 		  	 // when search result is zero
 				 // display the search result to the user
 				    if(cdColl.numOfMatchedSongName(c) == 0)
	 			    {
 				      System.out.println
 				      ("Number of matches is 0");
 				      System.out.println("\n");
 					}

                 // when search result is one or more than one
 				    else
 				    {
 		    	   // display number of matches
	 			      System.out.print
 				      ("Number of matches is ");
 				      System.out.println
	 			      (cdColl.numOfMatchedSongName(c));
 				      System.out.println("\n");

 			 	   // display info of the CDs found
		 			  cdColl.displayMatchSongNameInfo
		 			  (cdColl.searchSongName(c));
 					  System.out.println("\n");
 			 		}

		 			break;// break case 3 (look up song name)

		 		  	default: break;
 		     }// end switch selection of Lookup Menu

 		 break;// break case 4 (Main Menu selection)

// Load exiting database from file is selected
 		 case 5:
 		   cdColl.loadFile(stdin);
   		   break;

// Store database to file is selected
 		 case 6:
 		   cdColl.writeFile(stdin);
 		   break;

// Exit is selected
 		  case 7: redisplay = false;
 		    System.out.print("Database has been modified,");
 			System.out.println(" save changes? [Y or N]: ");
 			String y = stdin.readLine();

 			if(y.equalsIgnoreCase("y"))
			  cdColl.writeFile(stdin);
 			else
 		      System.exit(0);

 			break;
 		    default: break;
 	  	 }//end selection of Main Menu
 	  } while (redisplay); //end Main Menu


    }//end if statement when the user choose 'y'
 	//exit the program if the user is not ready to store any CDs
	else
		System.exit(0);
  }//end main class
}//end CDLibrary class
