/********************************* to column 80******************************
 Main Class:       Song Class
 Author:           Yannis Lau <yylau2@students.wisc.edu>
 Completion Date:  12-16-99
 Course:           CS 302, Fall '99, Section 311
 TA:               Daniel Tomko
 Assignment:       Project 2

 Compiler:         CodeWarrior (JDK 1.2)
 Platform:         Windows NT 4.0
 ****************************************************************************/

/**
 * Class Song
 * Represents Song objects and for other classes use
 *
 **/


class Song
{

/**
 * DATA MEMBERS
 **/
	private String songName;     // song name in the CD
	private int minutes;         // minutes of the song
	private int seconds;         // seconds of the song

/**
 * CONSTRUCTOR
 *
 **/
 	public Song()
 	{
 		if(minutes < 0)
 			this.minutes = 0;

 	// seconds should be between 0 to 59
 		if(seconds < 0 && seconds > 60)
 			this.seconds = 0;
 	}

/**********************************************************
 		Accessors
 **********************************************************/

/**
 * Set Song name
 * @param: (String) song name
 */
 	public void setSongName(String songName)
 	{
 		this.songName = songName;
 	}

/**
 * Set Song time (Minutes)
 * @param: (int) minutes
 */
 	public void setSongMins(int minutes)
 	{
 		if(minutes >= 0)
 			this.minutes = minutes;
 		else
 			this.minutes = 0;
 	}

/**
 * Set song time (Seconds)
 * @param: (int) seconds
 **/
 	public void setSongSecs(int seconds)
 	{
 	// seconds must be 0 or larger than zero and
 	// smaller than 60
 		if(seconds >= 0 && seconds < 60)
 			this.seconds = seconds;
 		else
 			seconds = 0;
 	}

/**********************************************************
 		Mutators
 **********************************************************/

 /**
  * Return Song name
  * @return: (String) song name
  **/
   	public String getSongName()
   	{
   		return songName;
   	}

 /**
  * Return Song time (Minutes)
  * @return: (int) minutes
  **/
  	public int getSongMin()
  	{
  		return minutes;
  	}

 /**
  * Return Song time (Seconds)
  * @return: (int) seconds
  **/
  	public int getSongSec()
  	{
  		return seconds;
  	}

/**
 * toString method
 * Display Song information as a String object
 * use to convert information to String
 * purpose: easy to store information to a file
 **/
  	public String toString()
  	{
  	  return (songName + '|' + minutes+ ':' + seconds + '|');
  	}

 }//end class MainMenu