/*******************************************************************************
 Main Class:       CDLibrary
 Author:           Chi-Kai (Clement) Chow chikaichow@students.wisc.edu
 Completion Date:  Tuesday, December 14th, 1999

 Course:           CS 302, Fall '99, Section 17
 TA:			   David Schneider
 Assignment:       Project 2

 Compiler:         CodeWarrior (JDK 1.2)
 Platform:         Windows NT 4.0
*******************************************************************************/

/*****************
 Represents a CD object with its data members; It contains accessor and
 mutator methods for the data members of a CD object (each containing a
 Song array)
  
 Bugs: None  			
******************/
class CD {

	private MyArray songs; //MyArray object that stores a Song array
	private String albumTitle, artist; //CD Title and artist name
	private int releaseYr; //Release Year, 1000-9999
	private int numSongs; //number of songs, 1-100
	private int totalTime; //total time (in seconds), 0-4800

	/*****************
	 Constructor - initializes all the data members to its valid states, 
	 creates a song array with an initial capacity of n, pass this 
	 array to create a MyArray object.
	 
	 @param n the number of songs initially
	******************/			
	public CD (int n) {
		
		Song [] s = new Song [n];
		//initialize all the elements in the array
		for (int i = 0; i < s.length; i++) {
			s[i] = new Song();
		}
		songs = new MyArray (s);
	
		albumTitle = "";
		artist = "";
		releaseYr = 0;
		numSongs = 0;
		totalTime = 0;
	}
	
	/*****************
	 Returns the song array of the CD
	
	 @return songs the MyArray object (of songs)
	******************/		
	public MyArray getMySongArray() {
	
		return songs;
		
	}	
	/*****************
	 Sets the albumTitle with the passed value
	 
	 @param a the album title
	******************/	
	public void setAlbumTitle(String a) { 
	
		albumTitle = a;
		
	}
		
	/*****************
	 Sets the artist with the passed value
	
	 @param b the artist name
	******************/	
	public void setArtist(String b)	{
	
		artist = b;
		
	}

	/*****************
	 Sets the releaseYr with the passed value
	 
	 @param r the release year
	******************/			
	public void setReleaseYr(int r) {
	
	    releaseYr = r;
	    
	} 

	/*****************
	 Sets the number of songs to the passed value
	
	 @param n the number of songs
	******************/		
	public void setNumSongs(int n) {
	
		numSongs = n;
		
	}	
	
	/*****************
	 Sets the total time to the passed value
	 
	 @param t the total time
	******************/		
	public void setTotalTime(int t) {
		//in seconds
		totalTime = t;
	
	}

	/*****************
	 Returns album title
	 
	 @return albumTitle
	******************/		
	public String getAlbumTitle() {
	
		return albumTitle;
		
	}		
	
	/*****************
	 Returns artist name
	 
	 @return artist
	******************/		
	public String getArtist() {
	
		return artist;
		
	}	
	
	/*****************
	 Returns release year
	 
	 @return releaseYr
	******************/		
	public int getReleaseYr() {
	
		return releaseYr;
		
	}	

	/*****************
	 Returns number of songs
	 
	 @return numSongs
	******************/		
	public int getNumSongs() {
	
		return numSongs;
		
	}	

	/*****************
	 Calculate the total time and returns the total time (in seconds)
	 
	 @return totalTime (after calculation, in seconds)
	******************/		
	public int getTotalTime() {
	    
	    //reset totalTime before adding
	    totalTime = 0;
	    //add each song's time to total (convert all to seconds)
	    for (int i = 0; i < songs.getSize(); i++) {
	    	Song song = (Song) songs.getElementAt(i);
	    	totalTime += song.getPlayMinute()*CDLibrary.SEC_IN_MIN +
	    				 song.getPlaySecond();
	    }	
		return totalTime;
	}

	/*****************
	 Returns a String for displaying a CD object
	 
	 @return String
	******************/		
	public String toString() {
		
		//convert total time back to minutes and seconds	
		return ("Artist: " + artist + "\nTitle: " + albumTitle + "\nYear: " +
				releaseYr + "\nTotal Time: " + totalTime/CDLibrary.SEC_IN_MIN
				+ ":" + totalTime%CDLibrary.SEC_IN_MIN + "\nNumber of Songs: "
				+ numSongs);
		
	}
}