/*******************************************************************************
 Main Class:       CDLibrary
 Author:           Chi-Kai (Clement) Chow chikaichow@students.wisc.edu
 Completion Date:  Tuesday, December 14th, 1999

 Course:           CS 302, Fall '99, Section 17
 TA:			   David Schneider
 Assignment:       Project 2

 Compiler:         CodeWarrior (JDK 1.2)
 Platform:         Windows NT 4.0
*******************************************************************************/

/*****************
 Represents a song object with its data members; It contains accessor and
 mutator methods for the data members of a Song object
  
 Bugs: None  			
******************/
class Song {

	private String songTitle; //Song Title
	private int playMinute, playSecond; //Play minutes and seconds
	
	/*****************
	 Constructor - initialize the data members to its valid states.  			
	******************/
	public Song(){	
		songTitle = "";
		playMinute = 0;
		playSecond = 0;
		}
	
	/*****************
	Constructor - set the data members to the passed values.  	
  	
  	@param t the song title
  	@param m the song's play minute
  	@param s the song's play second
	******************/	
	public void Song(String t, int m, int s) {
		songTitle = t;
		playMinute = m;
		playSecond = s;
	}	
	
	/*****************
	 sets songTitle to the passed value.
	 
	 @param t the song title
	******************/
	public void setSongTitle(String t) {
	
		songTitle = t;
		
	}	
	
	/*****************
	 sets playMinute to the passed value.
	 
	 @param m the song's play minute
	******************/	
	public void setPlayMinute(int m) {
	
		playMinute = m;
		
	}
	
	/*****************
	 sets playSecond to the passed value
	 
	 @param s the song's play second
	******************/		
	public void setPlaySecond(int s) {
	
		playSecond = s;
		
	}
	
	/*****************
	 returns song title 
	 
	 @return songTitle the song title
	******************/			
	public String getSongTitle() {
	
		return songTitle;
		
	}
	
	/*****************
	 returns song's play minute
	 
	 @return playMinute the play minute
	******************/		
	public int getPlayMinute() {
	
		return playMinute;
	
	}
	
	/*****************
	 returns song's play second
	 
	 @return playSecond the play second 
	******************/	
	public int getPlaySecond() {
	
		return playSecond;
		
	}	
	
	/*****************
	 returns a String for displaying a song object
	 
	 @return string
	******************/		
	public String toString() {
	
		return (songTitle + ", " + playMinute + ":" + playSecond);
		
	}
	
}
		