/******************************* FILE HEADER **********************************
      Main Class File:  CDDatabase.java
      File:             Song.java
      
      Author:           Data Fok / data@cs.wisc.edu
      Collaborators:    N/A

      Completion Date:  2000/12/8

      Course:           CS 302, Fall 2000, Section 14
      TA:               Jeff Shergali

      Compiler:         CodeWarrior IDE 4.0 (JDK 1.2)
      Platform:         Windows NT 4.0
**************************** 80 columns wide *********************************/

/*****************
 Represents a song object with its data members; It contains accessor and
 mutator methods for the data members of a Song object
  
 Bugs: None  			
******************/
class Song {
	
	private String name; //Song Title
	private int min, sec; //Play minute and play second
		
	/*****************
	Constructor - set the data members to the passed values.  	
  	
  	@param name the song title
  	@param min the song's play minute
  	@param sec the song's play second
	******************/
	public Song(String name, int min, int sec) {
		this.name = name;
		this.min = min;
		this.sec = sec;		
	}
	
	/*****************
	 Constructor - initialize the data members to its valid states.  			
	******************/
	public Song() {
		this("",0,0);
	}
	
	/*****************
	 sets name to the passed value.
	 
	 @param name the song title
	******************/
	public void setName(String name) {
		this.name = name;
	}
	
	/*****************
	 sets Time (min and sec) to the passed value
	 
	 @param min the song's play minute
	 @param s the song's play second
	******************/
	public void setTime(int min, int sec) {
		this.min = min;
		this.sec = sec;
	}
	
	/*****************
	 returns song title 
	 
	 @return name the song title
	******************/	
	public String getName() {
		return name;
	}
	
	/*****************
	 returns song's play time in String format (mm:ss)
	 
	 @return String the playTime of the song
	******************/	
	public String getTime() {
		String sTime, zero;
		if (sec < 10) {
			zero = "0";
		}
		else {
			zero = "";
		}
		sTime = min + ":" + zero + sec;
		return sTime;
	}
	
	/*****************
	 returns song's "total" play second
	 
	 @return tSec the play second 
	******************/
	public int getTotalSec() {
		int tSec = (int) (min * CDDatabase.SEC_IN_MIN + sec) ;
		return tSec;
	}
	
	/*****************
	 returns a String for output to a text file
	 
	 @return string
	******************/
	public String toString() {
		String songData = "|" + name + "|" + getTime();
		return songData;
	}
}
	