/******************************* MAIN HEADER **********************************
    Title:              Drawing It Together
    Files:              DrawingProgram.java
    
    Author:             Kelly Sorensen, kjs@cs.wisc.edu
    Collaborators:      none
    
    Due Date:           Monday, Sept. 25, 2000
    Completion Date:    Monday, Sept. 25, 2000
    
    Course:             CS 302, Fall 2000, Lecture 1
    TA:                 Kelly Sorensen
    
    Compiler:           CodeWarrior IDE 4.0 (JDK 1.2)
    Platform:           Windows NT 4.0
 **************************** 80 columns wide *********************************/

import javabook.*;      // package containing simple graphical user interface
import grid.*;          // package containing specialized drawing environment

/**
 * This program draws the designs (as specified in the Lesson 3 
 * description).
 **/
public class DrawingProgram {

    public static void main(String args[]) {
    
        // declare and create necessary objects
        DrawingGrid grid    = new DrawingGrid();      // the drawing grid
        grid.show();
        InputBox inputBox   = new InputBox(grid);     // for user input
        OutputBox outputBox = new OutputBox(grid);    // to display distances
        
        ///////////////////////////////
        // Step 3
        ///////////////////////////////
        Location loc = new Location(0,0);
        Marker mark = new Marker(loc, DrawingGrid.SQUARE, DrawingGrid.BLUE);
        grid.addMarker(mark);
        
        ///////////////////////////////
        // Step 4
        ///////////////////////////////
        Location secondLoc = new Location(5,10);
        Marker secondMark = new Marker(secondLoc, DrawingGrid.CIRCLE, DrawingGrid.RED);
        grid.addMarker(secondMark);
        
        ///////////////////////////////
        // Step 5
        ///////////////////////////////
        secondMark.move();  // NOTE: How Could
        secondMark.move();  // This Have Been
        secondMark.move();  // Done Quicker?
        
        //////////////////////////////////////
        // Step 6
        //        Having some fun :)
        //////////////////////////////////////
        secondMark.rotate();
        secondMark.move(2);
        grid.erase();
        
        Location k_loc = new Location(0,10);
        Marker k_mark = new Marker(k_loc, DrawingGrid.SQUARE, DrawingGrid.YELLOW);
        grid.addMarker(k_mark);
        k_mark.move(-10);
        k_mark.move(5);
        k_mark.rotate(-1);
        k_mark.move(5);
        k_mark.move(-5);
        k_mark.rotate(-2);
        k_mark.move(5);
        
        Location j_loc = new Location(12,5);
        Marker j_mark = new Marker(j_loc, DrawingGrid.CIRCLE, DrawingGrid.RED);
        grid.addMarker(j_mark);
        j_mark.move(-4);
        j_mark.rotate(5);
        j_mark.move();
        j_mark.rotate();
        j_mark.move(3);
        j_mark.rotate();
        j_mark.move();
        j_mark.rotate();
        j_mark.move(9);
        
        Location s_loc = new Location(24,7);
        Marker s_mark = new Marker(s_loc, DrawingGrid.SQUARE, DrawingGrid.BLUE);
        grid.addMarker(s_mark);
        s_mark.move(-3);
        s_mark.rotate(-2);
        s_mark.move(5);
        s_mark.rotate(2);
        s_mark.move(5);
        s_mark.rotate(2);
        s_mark.move(5);
        s_mark.rotate(-2);
        s_mark.move(3);
        s_mark.rotate(-2);
        s_mark.move(5);
        
        grid.erase();
        
        //////////////////////////////////
        // Step 7
        //////////////////////////////////
        Location squareLoc = new Location(3,3);
        Marker squareMarker = new Marker(squareLoc, DrawingGrid.SQUARE, DrawingGrid.BLUE);
        grid.addMarker(squareMarker);
        squareMarker.move(-6);
        squareMarker.rotate(-2);
        squareMarker.move(6);
        squareMarker.rotate(2);
        squareMarker.move(6);
        squareMarker.rotate(2);
        squareMarker.move(6);
        
        grid.erase();
        
        ////////////////////////////////////
        // Step 8-9
        ////////////////////////////////////
        int x = inputBox.getInteger("Please input the x-coordinate for the rectangle");
        int y = inputBox.getInteger("Please input the y-coordinate for the rectangle");
        
        grid.checkLocation(x,y);
        
        Location rectangleLoc = new Location(x,y);
        Marker rectangleMarker = new Marker(rectangleLoc, DrawingGrid.SQUARE, DrawingGrid.BLUE);
        grid.addMarker(rectangleMarker);
        rectangleMarker.move(-6);
        rectangleMarker.rotate(-2);
        rectangleMarker.move(6);
        rectangleMarker.rotate(2);
        rectangleMarker.move(6);
        rectangleMarker.rotate(2);
        rectangleMarker.move(6);
        
        grid.erase();
        
        /////////////////////////////////////
        // Step 10-13
        /////////////////////////////////////
        x = inputBox.getInteger("Please input the x-coordinate for the rectangle");
        y = inputBox.getInteger("Please input the y-coordinate for the rectangle");
        int width = inputBox.getInteger("Please input the width for the rectangle");
        int height = inputBox.getInteger("Please input the height for the rectangle");
        
        width = Math.abs(width);
        height = Math.abs(height);
        
        grid.checkLocation(x, y);
        grid.checkLocation(x + width, y + height);
        
        rectangleLoc = new Location(x,y);
        rectangleMarker = new Marker(rectangleLoc, DrawingGrid.SQUARE, DrawingGrid.BLUE);
        grid.addMarker(rectangleMarker);
        
        rectangleMarker.move(-height);
        rectangleMarker.rotate(-2);
        rectangleMarker.move(width);
        rectangleMarker.rotate(2);
        rectangleMarker.move(height);
        rectangleMarker.rotate(2);
        rectangleMarker.move(width);
        
        grid.erase();
        
        ///////////////////////////////////
        // Step 14
        ///////////////////////////////////
        double diagonal = Math.sqrt(Math.pow(width,2) + Math.pow(height,2));
        
        outputBox.printLine("The length of the diagonal is " + diagonal
                            + " units");
        outputBox.show();
         
    }  // end main
    
}  // end class DrawingProgram

