/* ****************************** MAIN HEADER **********************************
    Title:              Survival of the Fittest
    Files:             	Survivor.java, Time.java 

    Author:            	Jeffrey Shergalis	shergali@cs.wisc.edu 

    Due Date:          	10/06/2000 
    Completion Date:    10/01/2000 

    Course:             CS 302, Fall 2000, Section 14 
    TA:                 Jeff Shergalis 

    Compiler:           CodeWarrior IDE 4.0 (JDK 1.2)
    Platform:           Windows NT 4.0
 **************************** 80 columns wide *********************************/

/**
 *
 * The Survivor class is used to simulate two teams of people, moving at
 * different rates, but all heading to the same goal, and to determine
 * how long it will take them to reach the goal, as well as calculate
 * their distance to the goal
 *
 * Bugs: none known
 * @author Jeffrey Shergalis	shergali@cs.wisc.edu
 *
**/

import javabook.*;
import GUIStopWatch;
import Location;

public class Survivor 
{
    
	// constants we will use in our program
	public static final int OPAL_X = 250;
	public static final int OPAL_Y = 250;
	public static final double PAGONG_SPEED = 80.0;
	public static final double TAGI_SPEED = 100.0;

    public static void main(String[] args) 
	{
		Location pLoc, tLoc, oLoc;
		int pX, pY, tX, tY,pTime,tTime,pH,pM,pS,tH,tM,tS;
		double pDist, tDist;

		// create a main window and then an input box and output box
		MainWindow mainWindow = new MainWindow("Useless Window");
		InputBox inputBox = new InputBox(mainWindow);
		OutputBox outputBox = new OutputBox(mainWindow);

		// the set size enables us to make main window a little smaller
		// by default it almost completely fills the screen
		// Note: we must make mainWindow visible in order to call inputBox
		mainWindow.setSize(500,500);
		mainWindow.setVisible(true);

		// get the coordinates of the two tribes	
		// we use Math.abs to insure reading positive values
		pX = Math.abs(inputBox.getInteger(
			"Please enter the x-coordinate for Pagong"));
		pY = Math.abs(inputBox.getInteger(
			"Please enter the y-coordinate for Pagong"));
		tX = Math.abs(inputBox.getInteger(
			"Please enter the x-coordinate for Tagi"));
		tY = Math.abs(inputBox.getInteger(
			"Please enter the y-coordinate for Tagi"));

		// create the location objects with the user entered coordinates
		pLoc = new Location(pX,pY);
		tLoc = new Location(tX,tY);	
		oLoc = new Location(250,250);

		// now we compute the distance
		pDist = computeDistance(pLoc.getX(),pLoc.getY(),
				oLoc.getX(),oLoc.getY());
		tDist = computeDistance(tLoc.getX(),tLoc.getY(),
				oLoc.getX(),oLoc.getY());
		
		// we compute the time and cast it to an int (computeTime returns
		// a double)
		pTime = (int)computeTime(pDist,PAGONG_SPEED);
		tTime = (int)computeTime(tDist,TAGI_SPEED);		
		
		// we declare constants to make our code more readable
		final int SECS_PER_HOUR = 3600;
		final int SECS_PER_MIN = 60;

		// compute hours, minutes, and seconds
		pH = pTime / SECS_PER_HOUR;
		pTime = pTime % SECS_PER_HOUR;
		pM = pTime / SECS_PER_MIN;
		pTime = pTime % SECS_PER_MIN;
		pS = pTime;

		tH = tTime / SECS_PER_HOUR;
		tTime = tTime % SECS_PER_HOUR;
		tM = tTime / SECS_PER_MIN;
		tTime = tTime % SECS_PER_MIN;
		tS = tTime;

		/*--------------------  Note ----------------------------
			In this next section we make use of a shortcut operator
			*= and /=, both of these opperators work in the following
			manner:
			count *= 5; is the same as count = count * 5;
			count /= 5; is the same as count = count / 5;
		  	either way is acceptable, you just have to write less
			when you use *=,/= (there is also +=,-=,%=).
		---------------------       ----------------------------*/

		// here we need to round distance to the nearest 10th so
		// we multiply by 10, round off and divide by 10
		pDist *= 10.0;
		pDist = Math.round(pDist);
		pDist /= 10.0;

		tDist *= 10.0;
		tDist = Math.round(tDist);
		tDist /= 10.0;

		// fill the output box with our data
		outputBox.printLine("The Pagong team is " + pDist + "meters away from ");
		outputBox.printLine("the Opal mine and travels at " + (int)PAGONG_SPEED +
			" meters per minute, it ");
		outputBox.printLine("will take them " + pH + "h, " + pM + "min; " + pS +
			"sec to reach the Opal mine.");
		outputBox.printLine("The Tagi team is " + tDist + "meters away from ");
		outputBox.printLine("the Opal mine and travels at " + (int)TAGI_SPEED +
			" meters per minute, it ");
		outputBox.printLine("will take them " + tH + "h, " + tM + "min; " + tS +
			"sec to reach the Opal mine.");

		// display the output box
		outputBox.setVisible(true);

		GUIStopWatch stopWatch = new GUIStopWatch();

		// since we need three time objects representing hours, minutes and
		// seconds, and we want them all defaulted to zero, we can create
		// them when we actually call the method.
		stopWatch.displayGUI(new Time(),new Time(), new Time(), pLoc, tLoc);
   	} 

	/**
	 *
	 * computes distance between two given set of coordinates
	 *
	 * @param myX integer representing the starting x-coordinate
	 * @param myY integer representing the starting y-coordinate
	 * @param gX integer representing the final x-coordinate
	 * @param gY integer representing the final y-coordinate
	 *
	 * @return double containing distance between the two sets of coordinate
	 *
	**/
	private static double computeDistance(int myX, int myY, int gX, int gY)
	{
		return (Math.sqrt(Math.pow((myX-gX),2)+Math.pow((myY-gY),2)));
	}

	/**
	 *
	 * computes the time it will take to move the given distance based upon
	 * the given speed
	 *
	 * @param myDist double representing the distance to be traveled
	 * @param mySpeed double representing the speed the group will move
	 *
	 * @return double representing the time (in seconds) it will take to 
	 * move the given distance 
 	 *
	**/
	private static double computeTime(double myDist, double mySpeed)
	{
		final double SECS_PER_MIN = 60.0;
		return (myDist/mySpeed * SECS_PER_MIN);
	}
}
