/******************************* MAIN HEADER **********************************
    Title:              Survival of the Fittest
    Files:              Survivor.java, Time.java

    Author:             Data Fok / data@cs.wisc.edu

    Due Date:           2000/10/6
    Completion Date:    2000/10/1

    Course:             CS 302, Fall 2000, Section 14
    TA:                 Jeff Shergali

    Compiler:           CodeWarrior IDE 4.0 (JDK 1.2)
    Platform:           Windows NT 4.0
 **************************** 80 columns wide *********************************/

import javabook.*;

/**
 *The Survivor class will determine which tribes, Pagong and Tagi, to be the 
 *first to reach the Opal Mines(250,250). You will select the starting locations
 *for each tribe by entering their initial coordinates. Pagong's tribe has an 
 *injured member which slows their progress to 80 meters per minute. Meanwhile, 
 *Tagi's tribe can average 100 meters per minute. After you select the starting 
 *locations for each tribe, you will be able to view the progress each tribe 
 *makes towards the Opal Mines by viewing their updated progress through a
 *continuously updated graphic.
 *Bugs: May have one to two second difference in the calculated time 
 *		and the counted time. That is due to the different in rounding up in 
 *		GUIStopWatch and Survivor class.
 **/

class Survivor {
    
    //P_SPEED is the speed of Pagong
	//T_SPEED id the speed of Tagi 
    //the speed is meters per min
    private static final int P_SPEED = 80, T_SPEED = 100; 	
    
    //the location of the Opal Mine is (X_O, Y_O)
    private static final int X_O = 250, Y_O = 250;
        
    public static void main(String[] args) {
          
	    MainWindow mainWindow = new MainWindow();
	    mainWindow.setSize(500,500);
	    mainWindow.setVisible(true);
    
   		//x_p,y_p is the location of Pagong
		//x_t,y_t is the location of Tagi
   		int x_p,y_p,x_t,y_t; 	
    	
    	//distP is the distance of Pagong from the Opal Mine
    	//distT is the distanve of Tagi from the Opal Mine
    	double distP, distT; 
   		
   		//pHr,pMin,pSec is the time taken for Pagaong to reach the Opal Mine
   		//tHr,tMin.tSec is the time taken for Tagi to reach the Opal Minw
   		int pHr,pMin,pSec,tHr,tMin,tSec = 0;   		
   		
   		//creat inputBox to get the infomation from the user
   		InputBox inputBox = new InputBox(mainWindow);
    	x_p = inputBox.getInteger("Please enter the x-coordinate for Pagong: ");
    	y_p = inputBox.getInteger("Please enter the y-coordinate for Pagong: ");
    	x_t = inputBox.getInteger("Please enter the x-coordinate for Tagi: ");
    	y_t = inputBox.getInteger("Please enter the x-coordinate for Tagi: ");
    
    	//initation of the location of Pagong and Tagi
    	Location pLoc = new Location(x_p,y_p);
    	Location tLoc = new Location(x_t,y_t);
    	
    	//Calculate the distance of each tribes from the Opal Mine
    	distP = CalDist(x_p,y_p);
    	distT = CalDist(x_t,y_t);
    
    	//Calculate the time (in sec) taken by each tribes to Opal Mine
    	int pTime, tTime;
    	pTime = (int)Math.floor((distP/P_SPEED) * 60);
    	tTime = (int)Math.floor((distT/T_SPEED) * 60);
    	
    	//change the time from sec to hh:mm:ss format for both tribes    	
    	pHr = CalHr(pTime);
    	pMin = CalMin(pTime);
    	pSec = CalSec(pTime);
    	tHr = CalHr(tTime);
    	tMin = CalMin(tTime);
    	tSec = CalSec(tTime);
    	    	
    	//output the distance and time of each tribe
    	OutputBox outputBox = new OutputBox(mainWindow);
    	Display(outputBox, "Pagong", distP, P_SPEED, pHr, pMin, pSec);
    	outputBox.skipLine(1);
    	Display(outputBox, "Tagi", distT, T_SPEED, tHr, tMin, tSec);
    	outputBox.setVisible(true);
    
      	//These constants represent the max and min values for rollover used 
        //by Time objects of each value.
        final int MAX_VALUE = 59;
        final int MIN_VALUE = 0;
        int INITIAL_VALUE = 0;
        	
    	// The GUIStopWatch uses the Time objects to count up (like a stopwatch),
    	// which it does automatically.  It also automatically checks when the
    	// messages should be changed.
	    GUIStopWatch myWatch = new GUIStopWatch();
    	
    	/*
         A Time object is needed for each time fraction (i.e. hours, minutes,
	     and seconds), and they each are initialized to their minimum value.
	     */
	    /*
	     The "max value" for hourTime is set to 2147483647, which is the max value
	     for integer, as there is no actually limitation for the counted hour, 
	     it is just a "fake" max. value.
	     */	    
	   	      
	    Time hourTime = new Time(INITIAL_VALUE, 2147483647, MIN_VALUE); 
    	Time minTime = new Time(INITIAL_VALUE, MAX_VALUE, MIN_VALUE);
        Time secTime = new Time(INITIAL_VALUE, MAX_VALUE, MIN_VALUE);
            	
    	//display the GUIStopWatch
    	myWatch.displayGUI(hourTime, minTime, secTime, pLoc, tLoc);
        }
    
    
    /**
     *CalDist is used to calculate the distance between the tribes and the Opal
     *Mine.
     *@param x-coordinate of the starting point of the tribe
     *@param y-coordinate of the starting point of the tribe
     *@return distance between the starting point and the Opal Mine
    **/
    private static double CalDist(int x, int y)  {

    	double dist;
    	dist = Math.sqrt(Math.pow( (x - X_O), 2) + Math.pow ( (y - Y_O), 2));
    	return dist;
    }
    
    
    /**
     *Display method functions to display the distanve and the time of each tribe
     *@param oB the outputbox object for output
     *@param team the corresponding tribe name
     *@param dist distance between the tribe and the Opal Mine
     *@param speed speed of the tribe
     *@param hr   \
     *@param min   > time taken for the tribe to reach the Opal mine
     *@param sec  /
    **/
    private static void Display(OutputBox oB, String team, double dist, int speed, int hr, int min, int sec)  {	

		oB.print("The " + team + " team is " );
    	oB.print(Math.round(dist * 1000) / 1000.0);
    	oB.print(" meters away from the Opal mine and travels at ");
    	oB.print(speed);
    	oB.printLine(" meters per minute, ");
    	oB.print("it will take them ");
    	oB.print(hr + " hr; " + min + " min; " + sec + " sec ");
    	oB.printLine("to reach the Opal mine.");
    }	
	
	
	/**
	 *The 3 method to change the time in hh:mm:ss format from seconds
	 *@param rSec is the "raw time" (in sec) calculate by dividing the
	 *distance by Speed times 60
	**/
	private static int CalHr(int rSec)	{
		
		int hr;
		hr = (rSec/3600); //1 hours = 3600 sec
		return hr;
	}
	
	private static int CalMin(int rSec)	{
		
		int min;
		min = ((rSec%3600)/60 ); //1 min = 60 sec 
		return min;
	}	
	
	private static int CalSec(int rSec)	{
		
		int sec;		
		sec = ((rSec%3600)%60);
		return sec;		

	}

}

