/******************************* FILE HEADER **********************************
      Main Class File:  AlarmClockApp.java
      File:             AlarmClock.java
      
      Author:           Data Fok / data@cs.wisc.edu
      Collaborators:    N/A

      Completion Date:  10/13/2000

      Course:           CS 302, Fall 2000, Section 14
      TA:               Jeff Shergali

      Compiler:         CodeWarrior IDE 4.0 (JDK 1.2)
      Platform:         Windows NT 4.0
 **************************** 80 columns wide *********************************/

/**
 *AlarmClock class is use it to keep track of the current hours, 
 *minutes and seconds, detect when the alarm should go off and 
 *when the alarm should stop.
 */ 


class AlarmClock {

	//creat 3 time object to store the current Hour, Minute and Second
	private Time cHr;
	private Time cMin;
	private Time cSec;
	//alarm time H:M:S
	private int aHr, aMin ,aSec;
	private int dur; //duration of alarm
				
	//contructors
	
	public AlarmClock() {
		//store the current Hour, Minute and Second
		cHr = new Time(0,23,0);
		cMin = new Time();
		cSec = new Time(); 
		aHr = 0;
		aMin = 0;
		aSec = 0;
		dur = 0;	
	}
	
	
	public AlarmClock(int cH, int cM, int cS) {
		//store the current Hour, Minute and Second
		cHr = new Time(cH, 23, 0);
		cMin = new Time(cM);
		cSec = new Time(cS); 
	}
	
	public AlarmClock(int cH, int cM, int cS, int aH, int aM, int aS, int duration) {
		//store the current Hour, Minute and Second
		cHr = new Time(cH, 23, 0);
		cMin = new Time(cM);
		cSec = new Time(cS); 
		//store the alarm Hour, Minute and Second
		aHr = aH;
		aMin = aM;
		aSec = aS;
		//store the duration time
		dur = duration;
	}
	
	//detect whether or not the alarm should be set off
	private boolean alarmSetOff() {
		if ( (aHr == cHr.getValue() ) && (aMin == cMin.getValue() ) && (aSec == cSec.getValue() ) && (dur > 0)) {
			return true;
		}
		else {
			return false;
		}
	}
		
	//set stuffs
	//initiate the current time
	public void setCurrentTime(int cH, int cM, int cS) {
		cHr = new Time(cH, 23, 0);
		cMin = new Time(cM);
		cSec = new Time(cS); 
	}

	public void setAlarmTime(int aH, int aM, int aS) {
		aHr = aH;
		aMin = aM;
		aSec = aS;
	}
	
	public void setDur(int duration) {
		dur = duration;
	}
			
	//get stuffs
		
	public String getCurrentTime() {
		//return current time
		String cTime;
		int tHr, tMin, tSec; //temp storage of hour, minute and second
		tHr = cHr.getValue();
		tMin = cMin.getValue();
		tSec = cSec.getValue();
		cTime = tHr + ":" + tMin + ":" + tSec;
		return cTime;	
	}
	
	public int getCurrentHour() {
		//return
		return( cHr.getValue() );
	}
	
	public String getAlarmTime() {
		//return alarm time
		String aTime;
		aTime = aHr + ":" + aMin + ":" + aSec ;
		return aTime;
	}
	
	public int getDur() {
		//returen duration time of the alarm
		return dur;
	}
	
	public boolean getGoinOff() {
		return alarmSetOff();
	}
	
	//increment
	
	public void increOneSec() {
		boolean f1,f2,f3;
		
		f1 = cSec.increment();
		if ( f1 ) {
			f2 = cMin.increment();
			if ( f2 ) {
				f3 = cHr.increment();
			}
		}
	}

}