/******************************* MAIN HEADER **********************************
    Title:              Alarm Clock
    Files:              ATime.java, AlarmClock.java
    
    Author:             Data Fok / data@cs.wisc.edu
    
    Due Date:           10/16/2000
    Completion Date:    10/13/2000
    
    Course:             CS 302, Fall 2000, Section 14
    TA:                 Jeff Shergali
    
    Compiler:           CodeWarrior IDE 4.0 (JDK 1.2)
    Platform:           Windows NT 4.0
 **************************** 80 columns wide *********************************/

import lesson5.*;
import javabook.*;
import java.util.Calendar;

/**
 *The AlarmClockApp class create a AlarmClock object display the clock drawm 
 *form GUIAlarmDisplay class and set off the alarm and display the greeting 
 *as the alarm going off. Exit Program after alarm go off duration.
 */

class AlarmClockApp {
    
    public static int aHr = 0, aMin = 0 , aSec = 0; //initiate the alarm time H:M:S
    public static int dur = 0; //duration of the the alarm 
    
    public static void main(String[] args) {
    
    	int selection;
    	boolean keepLooping = true; 
    	String greeting;
    	    	
    	MainWindow mainWindow = new MainWindow("Useless Window");
    	mainWindow.setSize(500,500);
    	mainWindow.setVisible(true);
    	
    	InputBox inBox = new InputBox(mainWindow);
    	OutputBox outBox = new OutputBox(mainWindow);
    	MessageBox mBox = new MessageBox(mainWindow);
    	
    	//Create a ListBox
    	ListBox listBox = new ListBox(mainWindow);
    	listBox.addItem("Set Alarm Hour"); 
        listBox.addItem("Set Alarm Minute");
        listBox.addItem("Set Alarm Second");
        listBox.addItem("Set Alarm Duration");
        listBox.addItem("Start Alarm Clock");
        listBox.addItem("Exit Program");
        
    	/**
    	 *The outer while loop keep looping unless the user selected "Start Alarm Clock" or "Exit Program".
    	 *The inner while loop is use to validate the input hour, minute and second
    	 */ 	
    	while (keepLooping) {
    		
    		selection = listBox.getSelectedIndex();
    		
    		boolean flag = true; //the flag make sure the input data is vaild
    		
    		switch (selection) {
    		
    			case 0: while (flag) {  //looping until the input value is valid
    						aHr = inBox.getInteger("Set Alarm Hour: ");
    						if (aHr >= 0 && aHr < 24) {
    							flag = false;
    						}
    						else {
    							mBox.show("Invaild Entry, please try again!");
    						}
    					}
    					break;
    			case 1: while (flag) {  //looping until the input value is valid
    						aMin = inBox.getInteger("Set Alarm Minute: ");
    						if (aMin >= 0 && aMin < 60) {
    							flag = false;
    						}
    						else {
    							mBox.show("Invaild Entry, please try again!");
    						}
    					}
    					break;
    			case 2: while (flag) {  //looping until the input value is valid
    						aSec = inBox.getInteger("Set Alarm Second: ");
    						if (aSec >= 0 && aSec < 60) {
    							flag = false;
    						}
    						else {
    							mBox.show("Invaild Entry, please try again!");
    						}
    					}
    					break;
    			case 3: while (flag) {  //looping until the input value is valid
    						dur = inBox.getInteger("Set Alarm Duration: ");
    						if ( dur > 0 ) {
    							flag = false;
    						}
    						else {
    								mBox.show("Invaild Entry, please try again!");    	
    							 }    	
    					}
    					break;
    			case 4: outBox.printLine("Start Alarm Clock Selected");
    					keepLooping = false;  //stop looping and start the alarm clock
    					break;
    			case 5: System.exit(0);
    					break;
    			case ListBox.CANCEL: System.exit(0);
    						 		 break;
    			case ListBox.NO_SELECTION: mBox.show("You selected nothing, please make a selection.");
    									   break;
    		}
    	}
    	
    	//if the user do not input anything, the program will close
    	if ( aHr == 0 && aMin == 0 && aSec == 0 && dur == 0 ) {
    		mBox.show("You inputed nothing, program will close.");
    		System.exit(0);
    	}
    	
    	
    	//get current time (H:M:S)
    	Calendar myCalendar = Calendar.getInstance();
    	int cHr = myCalendar.get(Calendar.HOUR_OF_DAY); 
        int cMin = myCalendar.get(Calendar.MINUTE);  
        int cSec = myCalendar.get(Calendar.SECOND);  
    	    	
    	//create GUIAlarmClock
    	GUIAlarmDisplay myClockDis = new GUIAlarmDisplay();
    	myClockDis.setVisible(true);
    	
    	//creat and AlarmClock Object
    	AlarmClock myClock;
    	myClock = new AlarmClock();
    	myClock.setCurrentTime(cHr , cMin, cSec);
    	myClock.setAlarmTime(aHr, aMin, aSec);
    	myClock.setDur(dur);
    	
    	//while not set off display programmer 's name and keep tracking the time
    	while ( !( myClock.getGoinOff() ) ) {
    		myClockDis.update( myClock.getCurrentTime(),"Data Fok",myClock.getGoinOff() );
    		myClock.increOneSec();
    	}
    	
    	//while setting off display appropriate greeting and keep tracking the time
    	if ( myClock.getGoinOff() ) {
    		int tDur = myClock.getDur(); //get the duration time
    		while ( tDur > 0 ) {
    			//selection appropriate greeting
    			int tHr = myClock.getCurrentHour(); //get current hour
    			if ( tHr >= 6 && tHr < 12 ) {
    				greeting = "Good Morning!";
    			}
    			else if ( tHr >= 12 && tHr < 18 ) {
    					greeting = "Good Afternoon!";
    				 }
    				else if ( tHr >= 18 && tHr < 21 ) {
    						greeting = "Good Evening!";
    					 }
    					 else {
    					 	greeting = "Good Night!";
    					 }
    			myClockDis.update( myClock.getCurrentTime(),greeting,true );
    			myClock.increOneSec();
    			tDur--;
    		}
    	}
    	
    	//Exit program after the alarm
    	System.exit(0);
	}
}
